# LineSearches

[![Build Status](https://travis-ci.org/JuliaNLSolvers/LineSearches.jl.svg?branch=master)](https://travis-ci.org/JuliaNLSolvers/LineSearches.jl)
[![Codecov branch](https://img.shields.io/codecov/c/github/JuliaNLSolvers/LineSearches.jl/master.svg?maxAge=2592000)](https://codecov.io/gh/JuliaNLSolvers/LineSearches.jl)
[![][docs-stable-img]][docs-stable-url]
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)

## Description
This package provides an interface to line search algorithms implemented in Julia.
The code was originally written as part of [Optim](https://github.com/JuliaNLSolvers/Optim.jl),
but has now been separated out to its own package.

### Available line search algorithms
In [the docs](https://julianlsolvers.github.io/LineSearches.jl/latest/examples/generated/optim_linesearch.html) we show how to choose between the line search algorithms
in `Optim`.
* `HagerZhang` (Taken from the Conjugate Gradient implementation
  by Hager and Zhang, 2006)
* `MoreThuente` (From the algorithm in More and Thuente, 1994)
* `BackTracking` (Described in Nocedal and Wright, 2006)
* `StrongWolfe` (Nocedal and Wright)
* `Static` (Takes the proposed initial step length.)

### Available initial step length procedures
The package provides some procedures to calculate the initial step
length that is passed to the line search algorithm. See [the docs](https://julianlsolvers.github.io/LineSearches.jl/latest/examples/generated/optim_initialstep.html) for
its usage in `Optim`.
* `InitialPrevious` (Use the step length from the previous
  optimization iteration)
* `InitialStatic` (Use the same initial step length each time)
* `InitialHagerZhang` (Taken from Hager and Zhang, 2006)
* `InitialQuadratic` (Propose initial step length based on a quadratic
  interpolation)
* `InitialConstantChange` (Propose initial step length assuming
  constant change in step length)


## Documentation
For more details and options, see the documentation
- [STABLE][docs-stable-url] — most recently tagged version of the documentation.
- [LATEST][docs-latest-url] — in-development version of the documentation.

## Example usage
Here is how to get a simple linesearch for a one-dimensional function working:
```julia
using LineSearches

ϕ(x) = (x - π)^4
dϕ(x) = 4*(x-π)^3
ϕdϕ(x) = ϕ(x),dϕ(x)

α0 = 9.0
ϕ0 = ϕ(0.0)
dϕ0 = dϕ(0.0)

for ls in (Static,BackTracking,HagerZhang,MoreThuente,StrongWolfe)
    res = (ls())(ϕ, dϕ, ϕdϕ, α0, ϕ0,dϕ0)
    println(ls, ": ", res)
end
```
For more examples, see the documentation.

## References
- W. W. Hager and H. Zhang (2006) "Algorithm 851: CG_DESCENT, a conjugate gradient method with guaranteed descent." ACM Transactions on Mathematical Software 32: 113-137.
- Moré, Jorge J., and David J. Thuente. "Line search algorithms with guaranteed sufficient decrease." ACM Transactions on Mathematical Software (TOMS) 20.3 (1994): 286-307.
- Nocedal, Jorge, and Stephen Wright. "Numerical optimization." Springer Science & Business Media, 2006.


[docs-latest-img]: https://img.shields.io/badge/docs-latest-blue.svg
[docs-latest-url]: https://julianlsolvers.github.io/LineSearches.jl/latest

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://julianlsolvers.github.io/LineSearches.jl/stable

using LineSearches
using Test
import Aqua
import ExplicitImports
import JET

@testset "QA" begin
    @testset "Aqua" begin
        Aqua.test_all(LineSearches)
    end

    @testset "ExplicitImports" begin
        # No implicit imports (`using XY`)
        @test ExplicitImports.check_no_implicit_imports(LineSearches) === nothing

        # All explicit imports (`using XY: Z`) are loaded via their owners
        @test ExplicitImports.check_all_explicit_imports_via_owners(LineSearches) === nothing

        # No explicit imports (`using XY: Z`) that are not used
        @test ExplicitImports.check_no_stale_explicit_imports(LineSearches) === nothing

        # Nothing is accessed via modules other than its owner
        @test ExplicitImports.check_all_qualified_accesses_via_owners(LineSearches) === nothing

        # Almost no accesses of non-public names
        @test ExplicitImports.check_all_qualified_accesses_are_public(
            LineSearches;
            ignore = (
                :RefValue, # Base
                :max, # NaNMath
                :min, # NaNMath
            ),
        ) === nothing

        # No self-qualified accesses
        @test ExplicitImports.check_no_self_qualified_accesses(LineSearches) === nothing
    end

    @testset "JET" begin
        # Check that there are no undefined global references and undefined field accesses
        JET.test_package(LineSearches; target_defined_modules = true, mode = :typo)

        # Analyze methods based on their declared signature
        JET.test_package(LineSearches; target_defined_modules = true)
    end
end

using LineSearches
using NLSolversBase
using Test

if !isdefined(@__MODULE__, :LineSearchTestCase)
    include("TestCases.jl")
    using .TestCases
end

@testset "Capturing data" begin
    cache = LineSearchCache{Float64}()
    lsalgs =  (HagerZhang(; cache), StrongWolfe(; cache), MoreThuente(; cache),
               BackTracking(; cache), BackTracking(; order=2, cache) )
    ϕ(x) = (x - π)^4
    dϕ(x) = 4*(x-π)^3
    ϕdϕ(x) = (ϕ(x), dϕ(x))
    for ls in lsalgs
        α, val = ls(ϕ, dϕ, ϕdϕ, 10.0, ϕ(0), dϕ(0))
        @test α < 10
        @test length(cache.alphas) == length(cache.values) && length(cache.alphas) > 1
    end
end

# From PR#174
@testset "PR#174" begin
    tc = LineSearchTestCase(
        [0.0, 1.0, 5.0, 3.541670844449739],
        [3003.592409634743, 2962.0378569864743, 2891.4462095232184, 3000.9760725116876],
        [-22332.321416890798, -20423.214551925797, 11718.185026267562, -22286.821227217057]
    )
    fdf = OnceDifferentiable(tc)
    hz = HagerZhang()
    α, val = hz(fdf.f, fdf.fdf, 1.0, fdf.fdf(0.0)...)
    @test val <= minimum(tc)
end

@testset "PR#185" begin
    ϕ(α) = 1/(α+1)
    dϕ(α) = -1/(α+1)^2
    ϕdϕ(α) = ϕ(α), dϕ(α)

    α0 = 1.0
    ϕ0 = ϕ(0.0)
    dϕ0 = dϕ(0.0)

    _error_msg = @test_throws LineSearchException (HagerZhang())(ϕ, dϕ, ϕdϕ, α0, ϕ0, dϕ0)
    @test _error_msg.value.alpha > α0 # Should be something gigantic like 1e34
end

# # Optim initial step length guess
#
#-
#md # !!! tip
#md #     This example is also available as a Jupyter notebook:
#md #     [`optim_initialstep.ipynb`](@__NBVIEWER_ROOT_URL__examples/generated/optim_initialstep.ipynb)
#-
#
# This example shows how to use the initial step length procedures
# with [Optim](https://github.com/JuliaNLSolvers/Optim.jl).  We solve
# the Rosenbrock problem with two different procedures.
#
# First, run `Newton` with the (default) initial guess and line search procedures.
using Optim, LineSearches
import OptimTestProblems.MultivariateProblems
UP = MultivariateProblems.UnconstrainedProblems
prob = UP.examples["Rosenbrock"]

algo_st = Newton(alphaguess = InitialStatic(), linesearch = HagerZhang())
res_st = Optim.optimize(prob.f, prob.g!, prob.h!, prob.initial_x, method=algo_st)


# We can now try with the initial step length guess from Hager and Zhang.
algo_hz = Newton(alphaguess = InitialHagerZhang(α0=1.0), linesearch = HagerZhang())
res_hz = Optim.optimize(prob.f, prob.g!, prob.h!, prob.initial_x, method=algo_hz)


# From the result we see that this has reduced the number of function and gradient calls, but increased the number of iterations.

## Test the results                                       #src
using Test                                                #src
@test Optim.f_calls(res_hz) < Optim.f_calls(res_st)       #src
@test Optim.g_calls(res_hz) < Optim.g_calls(res_st)       #src
@test Optim.iterations(res_hz) > Optim.iterations(res_st) #src

# # Using LineSearches without Optim/NLsolve
#
#-
#md # !!! tip
#md #     This example is also available as a Jupyter notebook:
#md #     [`customoptimizer.ipynb`](@__NBVIEWER_ROOT_URL__examples/generated/customoptimizer.ipynb)
#-
#
# This tutorial shows you how to use the line search algorithms in `LineSearches`
# for your own optimization algorithm that is not part of `Optim` or `NLsolve`.
#
# Say we have written a gradient descent optimization algorithm but would like to
# experiment with different line search algorithms.
# The algorithm is implemented as follows.

using LinearAlgebra: norm, dot

function gdoptimize(f, g!, fg!, x0::AbstractArray{T}, linesearch,
                    maxiter::Int = 10000,
                    g_rtol::T = sqrt(eps(T)), g_atol::T = eps(T)) where T <: Number
    x = copy(x0)
    gvec = similar(x)
    g!(gvec, x)
    fx = f(x)

    gnorm = norm(gvec)
    gtol = max(g_rtol*gnorm, g_atol)

    ## Univariate line search functions
    ϕ(α) = f(x .+ α.*s)
    function dϕ(α)
        g!(gvec, x .+ α.*s)
        return dot(gvec, s)
    end
    function ϕdϕ(α)
        phi = fg!(gvec, x .+ α.*s)
        dphi = dot(gvec, s)
        return (phi, dphi)
    end

    s = similar(gvec) # Step direction

    iter = 0
    while iter < maxiter && gnorm > gtol
        iter += 1
        s .= -gvec

        dϕ_0 = dot(s, gvec)
        α, fx = linesearch(ϕ, dϕ, ϕdϕ, 1.0, fx, dϕ_0)

        @. x = x + α*s
        g!(gvec, x)
        gnorm = norm(gvec)
    end

    return (fx, x, iter)
end

# Note that there are many optimization and line search algorithms that allow
# the user to evaluate both the objective and the gradient at the same time, for
# computational efficiency reasons.
# We have included this functionality in the algorithm as the input function `fg!`,
# and even if the Gradient Descent algorithm does not use it explicitly, many of the
# LineSearches algorithms do.

# The Gradient Descent `gdoptimize` method selects a descent direction and calls
# the line search algorithm  `linesearch` which returns the step length `α` and the
# objective value `fx = f(x + α*s)`.
#
# The functions ϕ and dϕ represent a univariate objective
# and its derivative, which is used by the line search algorithms.
# To utilize the `fg!` function call in the optimizer, some of the line searches
# require a function ϕdϕ which returns the univariate objective and the
# derivative at the same time.


# ## Optimizing Rosenbrock
# Here is an example to show how we can combine `gdoptimize` and `LineSearches`
# to minimize the Rosenbrock function, which is defined by

f(x) = (1.0 - x[1])^2 + 100.0 * (x[2] - x[1]^2)^2

function g!(gvec, x)
    gvec[1] = -2.0 * (1.0 - x[1]) - 400.0 * (x[2] - x[1]^2) * x[1]
    gvec[2] = 200.0 * (x[2] - x[1]^2)
    gvec
end

function fg!(gvec, x)
    g!(gvec, x)
    f(x)
end


# We can now use `gdoptimize` with `BackTracking` to optimize the Rosenbrock function
# from a given initial condition `x0`.

x0 = [-1., 1.0]

using LineSearches
ls = BackTracking(order=3)
fx_bt3, x_bt3, iter_bt3 = gdoptimize(f, g!, fg!, x0, ls)

## Test the results                #src
using Test                         #src
@test fx_bt3 < 1e-12               #src
@test iter_bt3 < 10000             #src
@test x_bt3 ≈ [1.0, 1.0] atol=2e-7 #src

# Interestingly, the `StrongWolfe` line search converges in one iteration, whilst
# all the other algorithms take thousands of iterations.
# This is just luck due to the particular choice of initial condition

ls = StrongWolfe()
fx_sw, x_sw, iter_sw = gdoptimize(f, g!, fg!, x0, ls)

## Test the results               #src
@test fx_sw < 1e-12               #src
@test iter_sw < 10000             #src
@test x_sw ≈ [1.0, 1.0] atol=1e-7 #src


#md # ## [Plain Program](@id customoptimizer-plain-program)
#md #
#md # Below follows a version of the program without any comments.
#md # The file is also available here: [customoptimizer.jl](customoptimizer.jl)
#md #
#md # ```julia
#md # @__CODE__
#md # ```

# # Optim line search
#
#-
#md # !!! tip
#md #     This example is also available as a Jupyter notebook:
#md #     [`optim_linesearch.ipynb`](@__NBVIEWER_ROOT_URL__examples/generated/optim_linesearch.ipynb)
#-
#
# This example shows how to use `LineSearches` with
# [Optim](https://github.com/JuliaNLSolvers/Optim.jl).  We solve the
# Rosenbrock problem with two different line search algorithms.
#
# First, run `Newton` with the default line search algorithm:

using Optim, LineSearches
import OptimTestProblems.MultivariateProblems
UP = MultivariateProblems.UnconstrainedProblems
prob = UP.examples["Rosenbrock"]

algo_hz = Newton(linesearch = HagerZhang())
res_hz = Optim.optimize(prob.f, prob.g!, prob.h!, prob.initial_x, method=algo_hz)

# Now we can try `Newton` with the cubic backtracking line search,
# which reduced the number of objective and gradient calls.

algo_bt3 = Newton(linesearch = BackTracking(order=3))
res_bt3 = Optim.optimize(prob.f, prob.g!, prob.h!, prob.initial_x, method=algo_bt3)


## Test the results                                  #src
using Test                                           #src
@test Optim.f_calls(res_bt3) < Optim.f_calls(res_hz) #src
@test Optim.g_calls(res_bt3) < Optim.g_calls(res_hz) #src

@testset "Initial step guess" begin
    f(x) = dot(x, x)
    function g!(out, x)
        out[:] = 2x
    end

    x = [-1., -1.]
    df = NLSolversBase.OnceDifferentiable(f,g!,x)

    phi_0, grtmp = NLSolversBase.value_gradient!(df, x)
    p = -grtmp
    dphi_0 = dot(p, grtmp)

    function getstate()
        state = StateDummy(1.0,  x, similar(x), NaN, p)
    end
    # Test HagerZhang I0
    ls = HagerZhang()
    state = getstate()
    is = InitialHagerZhang(α0 = NaN)
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == 0.005
    @test ls.mayterminate[] == false

    # Test HagerZhang I12
    ls = HagerZhang()
    state = getstate()
    is = InitialHagerZhang(α0 = 1.0)
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == 0.4999999999999999
    @test ls.mayterminate[] == true
    dfinf = NLSolversBase.NonDifferentiable(x->Inf, x)
    is = InitialHagerZhang(α0 = 1.0)
    is(ls, state, phi_0, dphi_0, dfinf)
    @test state.alpha == 0
    @test ls.mayterminate[] == true

    # Test Static unscaled
    ls = HagerZhang()
    state = getstate()
    is = InitialStatic()
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == is.alpha
    @test ls.mayterminate[] == false

    # Test Static scaled
    ls = HagerZhang()
    state = getstate()
    is = InitialStatic(alpha = 0.5, scaled = true)
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == 0.5 / norm(state.s)
    @test ls.mayterminate[] == false
    is = InitialStatic(alpha = 0.5, scaled = true)
    state.s .= (is.alpha / 100)
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha ==  1.0
    @test ls.mayterminate[] == false

    # Test Previous
    ls = HagerZhang()
    state = getstate()
    alpha = state.alpha
    ls.mayterminate[] = true
    is = InitialPrevious()
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == alpha
    @test ls.mayterminate[] == true

    # Test Previous NaN
    ls = HagerZhang()
    state = getstate()
    state.alpha = NaN
    ls.mayterminate[] = true
    is = InitialPrevious()
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == is.alpha
    @test ls.mayterminate[] == true # InitialPrevious should not touch this!

    # Test Quadratic NaN
    ls = HagerZhang()
    state = getstate()
    is = InitialQuadratic()
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == is.α0
    @test ls.mayterminate[] == false

    # Test Quadratic
    ls = HagerZhang()
    state = getstate()
    state.f_x_previous = 2*phi_0
    is = InitialQuadratic(snap2one=(0.9,Inf))
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == 0.5
    @test ls.mayterminate[] == false

    # Test Quadratic snap2one
    ls = HagerZhang()
    state = getstate()
    state.f_x_previous = 2*phi_0
    is = InitialQuadratic(snap2one=(0.5,Inf))
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == 1.0
    @test ls.mayterminate[] == false

    # Test ConstantChange NaN
    ls = HagerZhang()
    state = getstate()
    is = InitialConstantChange()
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == is.α0
    @test ls.mayterminate[] == false

    # Test ConstantChange
    ls = HagerZhang()
    state = getstate()
    is = InitialConstantChange()
    is.dϕ_0_previous[] = 0.1*dphi_0
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == 0.25
    @test ls.mayterminate[] == false

    # Test ConstantChange snap2one
    ls = HagerZhang()
    state = getstate()
    is = InitialConstantChange(snap2one=(0.25,1.0))
    is.dϕ_0_previous[] = 0.1*dphi_0
    is(ls, state, phi_0, dphi_0, df)
    @test is.dϕ_0_previous[] == dphi_0
    @test state.alpha == 1.0
    @test ls.mayterminate[] == false
    dϕ_0_rand = rand()
    is(ls, state, phi_0, dϕ_0_rand, df)
    @test is.dϕ_0_previous[] == dϕ_0_rand
end

# generate examples
import Literate

# TODO: Remove items from `SKIPFILE` as soon as they run on the latest
# stable `Optim` (or other dependency)
#ONLYSTATIC = ["optim_linesearch.jl", "optim_initialstep.jl"]
ONLYSTATIC = []

EXAMPLEDIR = joinpath(@__DIR__, "src", "examples")
GENERATEDDIR = joinpath(@__DIR__, "src", "examples", "generated")
myfilter(str) = endswith(str, ".jl")
for example in filter!(myfilter, readdir(EXAMPLEDIR))
    input = abspath(joinpath(EXAMPLEDIR, example))
    script = Literate.script(input, GENERATEDDIR)
    code = strip(read(script, String))
    mdpost(str) = replace(str, "@__CODE__" => code)
    Literate.markdown(input, GENERATEDDIR, postprocess = mdpost,
                      documenter = !(example in ONLYSTATIC))
    Literate.notebook(input, GENERATEDDIR, execute = !(example in ONLYSTATIC))
end

@testset "alpha-calculations" begin
    import NLSolversBase

    f(x) = dot(x, x)
    function g!(out, x)
        out[:] = 2x
    end

    @testset "Quadratic function" begin
        lsalphas =     [1.0,   0.5, 0.5, 0.49995, 0.5,  0.5]  # types
                        # Stat  #HZ  wolfe   mt    bt3   bt2
        x = [-1., -1.]

        for (i, linesearch!) in enumerate(lstypes)
            debug_printing && println("Testing $(string(linesearch!))")
            df = NLSolversBase.OnceDifferentiable(f,g!,x)

            xtmp = copy(x)
            phi_0, grtmp = NLSolversBase.value_gradient!(df, x)
            p = -grtmp
            dphi_0 = dot(p, grtmp)

            alpha = 1.0
            if linesearch! == HagerZhang()
                linesearch!.mayterminate[] = false
            end

            alpha, ϕα = linesearch!(df, x, p, alpha, xtmp, phi_0, dphi_0)
            #xnew = x + alpha*p

            @test alpha ≈ lsalphas[i]
        end


        ### Test what happens at failures
        # x = [0, 0] is the minimum of f
        x = [0.0, 0.0]

        for (i, linesearch!) in enumerate(lstypes)
            debug_printing && println("Testing $(string(linesearch!))")
            df = NLSolversBase.OnceDifferentiable(f,g!,x)

            xtmp = copy(x)
            phi_0, grtmp = NLSolversBase.value_gradient!(df, x)
            p = -grtmp
            dphi_0 = dot(p, grtmp)

            alpha = 1.0
            if linesearch! == HagerZhang()
                linesearch!.mayterminate[] = false
            end

            if typeof(linesearch!) <: Union{HagerZhang, MoreThuente}
                @test_throws LineSearchException linesearch!(df, x, p, alpha,
                                                       xtmp, phi_0, dphi_0)
                try
                    linesearch!(df, x, p, alpha,
                                xtmp, phi_0, dphi_0)
                catch ex
                    @test ex.message == "Search direction is not a direction of descent."
                end
            else
                α, ϕα = linesearch!(df, x, p, alpha, xtmp, phi_0, dphi_0)
                @test ϕα == 0.0
                @test alpha == α # Is this what we want for zero-slope directions?
            end
        end
    end

    @testset "Himmelblau" begin
        # This should be a bit more difficult, so hopefully it hits more of the algorithm steps
        pr = OptimTestProblems.UnconstrainedProblems.examples["Himmelblau"]
        x0 = copy(pr.initial_x)


        s = [42.0,18.0]

        mayterminate = Ref{Bool}(false)
        alpha = 1.0; xtmp = zero(x0)

        lsalphas =  [1.0,                  # Static
                     0.01375274240750926,  # HZ
                     0.020646100006834013, # Wolfe
                     0.0175892025844326,   # MT
                     0.020545340808876406, # BT(3)
                     0.010000000000000002] # BT(2)
        for (i, ls) in enumerate(lstypes)
            debug_printing && println("Testing $(string(ls))")

            phi_0 = 26.0
            dphi_0 = -2088.0

            df = NLSolversBase.OnceDifferentiable(pr.f, pr.g!, x0)

            stepsize, ϕstepsize = ls(df, x0, s, alpha, xtmp, phi_0, dphi_0)

            @test stepsize ≈ lsalphas[i]
        end
    end
end

"""
`Static`: defines a static linesearch which returns the initial step length.

`Static` is intended for methods with well-scaled updates; i.e. Newton, on well-behaved problems.
"""
struct Static <: AbstractLineSearch end

function (ls::Static)(df::AbstractObjective, x, s, α, x_new = similar(x), ϕ_0 = nothing, dϕ_0 = nothing)
    ϕ = make_ϕ(df, x_new, x, s)
    ls(ϕ, α)
end

(ls::Static)(ϕ, dϕ, ϕdϕ, α, ϕ_0, dϕ_0) = ls(ϕ, α)

# TODO: Should we deprecate the interface that only uses the ϕ argument?
function (ls::Static)(ϕ, α::Tα) where Tα
    @assert α > real(Tα(0))
    ϕα = ϕ(α)

    # Hard-coded backtrack until we find a finite function value
    iterfinite = 0
    iterfinitemax = -log2(eps(real(Tα)))
    while !isfinite(ϕα) && iterfinite < iterfinitemax
        iterfinite += 1
        αold = α
        α    = αold/2

        ϕα = ϕ(α)
    end

    return α, ϕα
end

if Base.HOME_PROJECT[] !== nothing
    # JuliaLang/julia/pull/28625
    Base.HOME_PROJECT[] = abspath(Base.HOME_PROJECT[])
end

using Documenter, LineSearches

# Generate examples
include("generate.jl")

GENERATEDEXAMPLES = [joinpath("examples", "generated", f) for f in (
    "customoptimizer.md", "optim_linesearch.md", "optim_initialstep.md")]

# Build documentation.
makedocs(
    format = :html,
    sitename = "LineSearches.jl",
    doctest = false,
    # strict = VERSION.minor == 7 && sizeof(Int) == 8, # only strict mode on 0.7 and Int64
    strict = false,
    pages = Any[
        "Home" => "index.md",
        "Examples" => GENERATEDEXAMPLES,
        "API Reference" => [
            "reference/linesearch.md",
            "reference/initialstep.md",
            ]
        ]
    )

# Deploy built documentation from Travis.
deploydocs(
    repo = "github.com/JuliaNLSolvers/LineSearches.jl.git",
    target = "build",
    julia = "1.0", # deploy from release bot
    deps = nothing,
    make = nothing,
)

module TestCases

# A module for reproducing simplified versions of objective functions that cause trouble for line search methods

using NLSolversBase

export LineSearchTestCase

struct LineSearchTestCase
    alphas::Vector{Float64}
    values::Vector{Float64}
    slopes::Vector{Float64}

    function LineSearchTestCase(alphas, values, slopes)
        Base.require_one_based_indexing(alphas, values, slopes)
        n = length(alphas)
        if n != length(values) || n != length(slopes)
            throw(ArgumentError("Lengths of alphas, values, and slopes must match"))
        end
        # Ensure ordered & unique
        perm = sortperm(alphas)
        delidx = Int[]
        for i in firstindex(perm)+1:lastindex(perm)
            if alphas[perm[i]] == alphas[perm[i-1]]
                push!(delidx, i)
            end
        end
        deleteat!(perm, delidx)
        alphas, values, slopes = alphas[perm], values[perm], slopes[perm]
        # For interpolation, add a dummy value at the end
        push!(alphas, alphas[end]+1)
        push!(values, values[end])
        push!(slopes, 0.0)
        return new(alphas, values, slopes)
    end
end

Base.minimum(tc::LineSearchTestCase) = minimum(tc.values)

function NLSolversBase.OnceDifferentiable(tc::LineSearchTestCase)
    function fdf(x)
        x < zero(x) && throw(ArgumentError("x must be nonnegative, got $x"))
        i = findfirst(>(x), tc.alphas)
        (i === nothing || x > tc.alphas[end-1]) && throw(ArgumentError("x must be <=$(tc.alphas[end-1]), got $x"))
        i -= 1
        xk = tc.alphas[i]
        xkp1 = tc.alphas[i + 1]
        dx = xkp1 - xk
        t = (x - xk) / dx
        h00t = 2t^3 - 3t^2 + 1
        h10t = t * (1 - t)^2
        h01t = t^2 * (3 - 2t)
        h11t = t^2 * (t - 1)
        val =
            h00t * tc.values[i] +
            h10t * dx * tc.slopes[i] +
            h01t * tc.values[i + 1] +
            h11t * dx * tc.slopes[i + 1]
        h00tp = 6t^2 - 6t
        h10tp = 3t^2 - 4t + 1
        h01tp = -6t^2 + 6 * t
        h11tp = 3t^2 - 2t
        slope =
            (
                h00tp * tc.values[i] +
                h10tp * dx * tc.slopes[i] +
                h01tp * tc.values[i + 1] +
                h11tp * dx * tc.slopes[i + 1]
            ) / dx
        return val, slope
    end
    return OnceDifferentiable(α -> fdf(α)[1], α -> fdf(α)[2], fdf, [0.0])
end

end

#
# Conjugate gradient line search implementation from:
#   W. W. Hager and H. Zhang (2006) Algorithm 851: CG_DESCENT, a
#     conjugate gradient method with guaranteed descent. ACM
#     Transactions on Mathematical Software 32: 113–137.
#
# Code comments such as "HZ, stage X" or "HZ, eqs Y" are with
# reference to a particular point in this paper.
#
# There are some modifications and/or extensions from what's in the
# paper (these may or may not be extensions of the cg_descent code
# that can be downloaded from Hager's site; his code has undergone
# numerous revisions since publication of the paper):
# linesearch: the Wolfe conditions are checked only after alpha is
#   generated either by quadratic interpolation or secant
#   interpolation, not when alpha is generated by bisection or
#   expansion. This increases the likelihood that alpha will be a
#   good approximation of the minimum.
#
# linesearch: In step I2, we multiply by psi2 only if the convexity
#   test failed, not if the function-value test failed. This
#   prevents one from going uphill further when you already know
#   you're already higher than the point at alpha=0.
#
# both: checks for Inf/NaN function values
#
# both: support maximum value of alpha (equivalently, c). This
#   facilitates using these routines for constrained minimization
#   when you can calculate the distance along the path to the
#   disallowed region. (When you can't easily calculate that
#   distance, it can still be handled by returning Inf/NaN for
#   exterior points. It's just more efficient if you know the
#   maximum, because you don't have to test values that won't
#   work.) The maximum should be specified as the largest value for
#   which a finite value will be returned.  See, e.g., limits_box
#   below.  The default value for alphamax is Inf. See alphamaxfunc
#   for cgdescent and alphamax for HagerZhang.



# TODO: Remove these bitfield things and create a proper
# tracing functionality instead

# Display flags are represented as a bitfield
# (not exported, but can use via LineSearches.ITER, for example)
const one64 = convert(UInt64, 1)
const FINAL       = one64
const ITER        = one64 << 1
const PARAMETERS  = one64 << 2
const GRADIENT    = one64 << 3
const SEARCHDIR   = one64 << 4
const ALPHA       = one64 << 5
const BETA        = one64 << 6
# const ALPHAGUESS  = one64 << 7 TODO: not needed
const BRACKET     = one64 << 8
const LINESEARCH  = one64 << 9
const UPDATE      = one64 << 10
const SECANT2     = one64 << 11
const BISECT      = one64 << 12
const BARRIERCOEF = one64 << 13
display_nextbit = 14


const DEFAULTDELTA = 0.1 # Values taken from HZ paper (Nocedal & Wright recommends 0.01?)
const DEFAULTSIGMA = 0.9 # Values taken from HZ paper (Nocedal & Wright recommends 0.1 for GradientDescent)


# NOTE:
#   [1] The type `T` in the `HagerZhang{T}` need not be the same `T` as in
#       `hagerzhang!{T}`; in the latter, `T` comes from the input vector `x`.
#   [2] the only method parameter that is not included in the
#       type is `iterfinitemax` since this value needs to be
#       inferred from the input vector `x` and not from the type information
#       on the parameters


"""
Conjugate gradient line search implementation from:
  W. W. Hager and H. Zhang (2006) Algorithm 851: CG_DESCENT, a
    conjugate gradient method with guaranteed descent. ACM
    Transactions on Mathematical Software 32: 113–137.
"""
@kwdef struct HagerZhang{T, Tm} <: AbstractLineSearch
   delta::T = DEFAULTDELTA # c_1 Wolfe sufficient decrease condition
   sigma::T = DEFAULTSIGMA # c_2 Wolfe curvature condition (Recommend 0.1 for GradientDescent)
   alphamax::T = Inf
   rho::T = 5.0
   epsilon::T = 1e-6
   gamma::T = 0.66
   linesearchmax::Int = 50
   psi3::T = 0.1
   display::Int = 0
   mayterminate::Tm = Ref{Bool}(false)
   cache::Union{Nothing,LineSearchCache{T}} = nothing
   check_flatness::Bool = false
end
HagerZhang{T}(args...; kwargs...) where T = HagerZhang{T, Base.RefValue{Bool}}(args...; kwargs...)

function (ls::HagerZhang)(df::AbstractObjective, x::AbstractArray{T},
                          s::AbstractArray{T}, α::Real,
                          x_new::AbstractArray{T}, phi_0::Real, dphi_0::Real) where T
    ϕ, ϕdϕ = make_ϕ_ϕdϕ(df, x_new, x, s)
    ls(ϕ, ϕdϕ, α::Real, phi_0, dphi_0)
end

(ls::HagerZhang)(ϕ, dϕ, ϕdϕ, c, phi_0, dphi_0) = ls(ϕ, ϕdϕ, c, phi_0, dphi_0)

# TODO: Should we deprecate the interface that only uses the ϕ and ϕd\phi arguments?
function (ls::HagerZhang)(ϕ, ϕdϕ,
                          c::T,
                          phi_0::Real,
                          dphi_0::Real) where T # Should c and phi_0 be same type?
    (; delta, sigma, alphamax, rho, epsilon, gamma,
            linesearchmax, psi3, display, mayterminate, cache) = ls
    emptycache!(cache)

    zeroT = convert(T, 0)
    pushcache!(cache, zeroT, phi_0, dphi_0)
    if !(isfinite(phi_0) && isfinite(dphi_0))
        throw(LineSearchException("Value and slope at step length = 0 must be finite.", T(0)))
    end
    if dphi_0 >= eps(T) * abs(phi_0)
        throw(LineSearchException("Search direction is not a direction of descent.", T(0)))
    elseif dphi_0 >= 0
        return zeroT, phi_0
    end

    # Prevent values of x_new = x+αs that are likely to make
    # ϕ(x_new) infinite
    iterfinitemax::Int = ceil(Int, -log2(eps(T)))
    if cache !== nothing
        (; alphas, values, slopes) = cache
    else
        alphas = [zeroT] # for bisection
        values = [phi_0]
        slopes = [dphi_0]
    end
    if display & LINESEARCH > 0
        println("New linesearch")
    end


    phi_lim = phi_0 + epsilon * abs(phi_0)
    @assert c >= 0
    c <= eps(T) && return zeroT, phi_0
    @assert isfinite(c) && c <= alphamax
    phi_c, dphi_c = ϕdϕ(c)
    iterfinite = 1
    while !(isfinite(phi_c) && isfinite(dphi_c)) && iterfinite < iterfinitemax
        mayterminate[] = false
        iterfinite += 1
        c *= psi3
        phi_c, dphi_c = ϕdϕ(c)
    end
    if !(isfinite(phi_c) && isfinite(dphi_c))
        @warn("Failed to achieve finite new evaluation point, using alpha=0")
        mayterminate[] = false # reset in case another initial guess is used next
        return zeroT, phi_0
    end
    push!(alphas, c)
    push!(values, phi_c)
    push!(slopes, dphi_c)

    # If c was generated by quadratic interpolation, check whether it
    # satisfies the Wolfe conditions
    if mayterminate[] &&
          satisfies_wolfe(c, phi_c, dphi_c, phi_0, dphi_0, phi_lim, delta, sigma)
        if display & LINESEARCH > 0
            println("Wolfe condition satisfied on point alpha = ", c)
        end
        mayterminate[] = false # reset in case another initial guess is used next
        return c, phi_c # phi_c
    end
    # Initial bracketing step (HZ, stages B0-B3)
    isbracketed = false
    ia = 1
    ib = 2
    @assert length(alphas) == 2
    iter = 1
    cold = -one(T)
    while !isbracketed && iter < linesearchmax
        if display & BRACKET > 0
            println("bracketing: ia = ", ia,
                    ", ib = ", ib,
                    ", c = ", c,
                    ", phi_c = ", phi_c,
                    ", dphi_c = ", dphi_c)
        end
        if dphi_c >= zeroT
            # We've reached the upward slope, so we have b; examine
            # previous values to find a
            ib = length(alphas)
            for i = (ib - 1):-1:1
                if values[i] <= phi_lim
                    ia = i
                    break
                end
            end
            isbracketed = true
        elseif values[end] > phi_lim
            # The value is higher, but the slope is downward, so we must
            # have crested over the peak. Use bisection.
            ib = length(alphas)
            ia = 1
            if c ≉  alphas[ib] || slopes[ib] >= zeroT
                error("c = ", c)
            end
            # ia, ib = bisect(phi, lsr, ia, ib, phi_lim) # TODO: Pass options
            ia, ib = bisect!(ϕdϕ, alphas, values, slopes, ia, ib, phi_lim, display)
            isbracketed = true
        else
            # We'll still going downhill, expand the interval and try again.
            # Reaching this branch means that dphi_c < 0 and phi_c <= phi_0 + ϵ_k
            # So cold = c has a lower objective than phi_0 up to epsilon.
            # This makes it a viable step to return if bracketing fails.

            # Bracketing can fail if no cold < c <= alphamax can be found with finite phi_c and dphi_c.
            # Going back to the loop with c = cold will only result in infinite cycling.
            # So returning (cold, phi_cold) and exiting the line search is the best move.
            cold = c
            phi_cold = phi_c
            if nextfloat(cold) >= alphamax
                mayterminate[] = false # reset in case another initial guess is used next
                return cold, phi_cold
            end
            c *= rho
            if c > alphamax
                c = alphamax
                if display & BRACKET > 0
                    println("bracket: exceeding alphamax, using c = alphamax = ", alphamax,
                    ", cold = ", cold)
                end
            end
            phi_c, dphi_c = ϕdϕ(c)
            iterfinite = 1
            while !(isfinite(phi_c) && isfinite(dphi_c)) && c > nextfloat(cold) && iterfinite < iterfinitemax
                alphamax = c # shrinks alphamax, assumes that steps >= c can never have finite phi_c and dphi_c
                iterfinite += 1
                if display & BRACKET > 0
                    println("bracket: non-finite value, bisection")
                end
                c = (cold + c) / 2
                phi_c, dphi_c = ϕdϕ(c)
            end
            if !(isfinite(phi_c) && isfinite(dphi_c))
                if display & BRACKET > 0
                    println("Warning: failed to expand interval to bracket with finite values. If this happens frequently, check your function and gradient.")
                    println("c = ", c,
                            ", alphamax = ", alphamax,
                            ", phi_c = ", phi_c,
                            ", dphi_c = ", dphi_c)
                end
                return cold, phi_cold
            end
            push!(alphas, c)
            push!(values, phi_c)
            push!(slopes, dphi_c)
        end
        iter += 1
    end
    while iter < linesearchmax
        a = alphas[ia]
        b = alphas[ib]
        @assert b > a
        if display & LINESEARCH > 0
            println("linesearch: ia = ", ia,
                    ", ib = ", ib,
                    ", a = ", a,
                    ", b = ", b,
                    ", phi(a) = ", values[ia],
                    ", phi(b) = ", values[ib])
        end
        if b - a <= eps(b)
            mayterminate[] = false # reset in case another initial guess is used next
            return a, values[ia] # lsr.value[ia]
        end
        iswolfe, iA, iB = secant2!(ϕdϕ, alphas, values, slopes, ia, ib, phi_lim, delta, sigma, display)
        if iswolfe
            mayterminate[] = false # reset in case another initial guess is used next
            return alphas[iA], values[iA] # lsr.value[iA]
        end
        A = alphas[iA]
        B = alphas[iB]
        @assert B > A
        if B - A < gamma * (b - a)
            if display & LINESEARCH > 0
                println("Linesearch: secant succeeded")
            end
            if ls.check_flatness && nextfloat(values[ia]) >= values[ib] && nextfloat(values[iA]) >= values[iB]
                # It's so flat, secant didn't do anything useful, time to quit
                if display & LINESEARCH > 0
                    println("Linesearch: secant suggests it's flat")
                end
                mayterminate[] = false # reset in case another initial guess is used next

                return A, values[iA]
            end
            ia = iA
            ib = iB
        else
            # Secant is converging too slowly, use bisection
            if display & LINESEARCH > 0
                println("Linesearch: secant failed, using bisection")
            end
            c = (A + B) / convert(T, 2)

            phi_c, dphi_c = ϕdϕ(c)
            @assert isfinite(phi_c) && isfinite(dphi_c)
            push!(alphas, c)
            push!(values, phi_c)
            push!(slopes, dphi_c)

            ia, ib = update!(ϕdϕ, alphas, values, slopes, iA, iB, length(alphas), phi_lim, display)
        end
        iter += 1
    end

    best_alpha = alphas[argmin(values)]
    throw(LineSearchException("Linesearch failed to converge, reached maximum iterations $(linesearchmax).",
                              best_alpha))
end

# Check Wolfe & approximate Wolfe
function satisfies_wolfe(c::T,
                         phi_c::Real,
                         dphi_c::Real,
                         phi_0::Real,
                         dphi_0::Real,
                         phi_lim::Real,
                         delta::Real,
                         sigma::Real) where T<:Number
    wolfe1 = delta * dphi_0 >= (phi_c - phi_0) / c &&
               dphi_c >= sigma * dphi_0
    wolfe2 = (2 * delta - 1) * dphi_0 >= dphi_c >= sigma * dphi_0 &&
               phi_c <= phi_lim
    return wolfe1 || wolfe2
end

# HZ, stages S1-S4
function secant(a::Real, b::Real, dphi_a::Real, dphi_b::Real)
    return (a * dphi_b - b * dphi_a) / (dphi_b - dphi_a)
end
function secant(alphas, values, slopes, ia::Integer, ib::Integer)
    return secant(alphas[ia], alphas[ib], slopes[ia], slopes[ib])
end
# phi
function secant2!(ϕdϕ,
                  alphas,
                  values,
                  slopes,
                  ia::Integer,
                  ib::Integer,
                  phi_lim::Real,
                  delta::Real = DEFAULTDELTA,
                  sigma::Real = DEFAULTSIGMA,
                  display::Integer = 0)
    phi_0 = values[1]
    dphi_0 = slopes[1]
    a = alphas[ia]
    b = alphas[ib]
    dphi_a = slopes[ia]
    dphi_b = slopes[ib]
    T = eltype(slopes)
    zeroT = convert(T, 0)
    if !(dphi_a < zeroT && dphi_b >= zeroT)
        error(string("Search direction is not a direction of descent; ",
                     "this error may indicate that user-provided derivatives are inaccurate. ",
                      @sprintf "(dphi_a = %f; dphi_b = %f)" dphi_a dphi_b))
    end
    c = secant(a, b, dphi_a, dphi_b)
    if display & SECANT2 > 0
        println("secant2: a = ", a, ", b = ", b, ", c = ", c)
    end
    @assert isfinite(c)
    # phi_c = phi(tmpc, c) # Replace
    phi_c, dphi_c = ϕdϕ(c)
    @assert isfinite(phi_c) && isfinite(dphi_c)

    push!(alphas, c)
    push!(values, phi_c)
    push!(slopes, dphi_c)

    ic = length(alphas)
    if satisfies_wolfe(c, phi_c, dphi_c, phi_0, dphi_0, phi_lim, delta, sigma)
        if display & SECANT2 > 0
            println("secant2: first c satisfied Wolfe conditions")
        end
        return true, ic, ic
    end

    iA, iB = update!(ϕdϕ, alphas, values, slopes, ia, ib, ic, phi_lim, display)
    if display & SECANT2 > 0
        println("secant2: iA = ", iA, ", iB = ", iB, ", ic = ", ic)
    end
    a = alphas[iA]
    b = alphas[iB]
    doupdate = false
    if iB == ic
        # we updated b, make sure we also update a
        c = secant(alphas, values, slopes, ib, iB)
    elseif iA == ic
        # we updated a, do it for b too
        c = secant(alphas, values, slopes, ia, iA)
    end
    if (iA == ic || iB == ic) && a <= c <= b
        if display & SECANT2 > 0
            println("secant2: second c = ", c)
        end
        # phi_c = phi(tmpc, c) # TODO: Replace
        phi_c, dphi_c = ϕdϕ(c)
        @assert isfinite(phi_c) && isfinite(dphi_c)

        push!(alphas, c)
        push!(values, phi_c)
        push!(slopes, dphi_c)

        ic = length(alphas)
        # Check arguments here
        if satisfies_wolfe(c, phi_c, dphi_c, phi_0, dphi_0, phi_lim, delta, sigma)
            if display & SECANT2 > 0
                println("secant2: second c satisfied Wolfe conditions")
            end
            return true, ic, ic
        end
        iA, iB = update!(ϕdϕ, alphas, values, slopes, iA, iB, ic, phi_lim, display)
    end
    if display & SECANT2 > 0
        println("secant2 output: a = ", alphas[iA], ", b = ", alphas[iB])
    end
    return false, iA, iB
end

# HZ, stages U0-U3
# Given a third point, pick the best two that retain the bracket
# around the minimum (as defined by HZ, eq. 29)
# b will be the upper bound, and a the lower bound
function update!(ϕdϕ,
                 alphas,
                 values,
                 slopes,
                 ia::Integer,
                 ib::Integer,
                 ic::Integer,
                 phi_lim::Real,
                 display::Integer = 0)
    a = alphas[ia]
    b = alphas[ib]
    T = eltype(slopes)
    zeroT = convert(T, 0)
    # Debugging (HZ, eq. 4.4):
    @assert slopes[ia] < zeroT
    @assert values[ia] <= phi_lim
    @assert slopes[ib] >= zeroT
    @assert b > a
    c = alphas[ic]
    phi_c = values[ic]
    dphi_c = slopes[ic]
    if display & UPDATE > 0
        println("update: ia = ", ia,
                ", a = ", a,
                ", ib = ", ib,
                ", b = ", b,
                ", c = ", c,
                ", phi_c = ", phi_c,
                ", dphi_c = ", dphi_c)
    end
    if c < a || c > b
        return ia, ib #, 0, 0  # it's out of the bracketing interval
    end
    if dphi_c >= zeroT
        return ia, ic #, 0, 0  # replace b with a closer point
    end
    # We know dphi_c < 0. However, phi may not be monotonic between a
    # and c, so check that the value is also smaller than phi_0.  (It's
    # more dangerous to replace a than b, since we're leaving the
    # secure environment of alpha=0; that's why we didn't check this
    # above.)
    if phi_c <= phi_lim
        return ic, ib#, 0, 0  # replace a
    end
    # phi_c is bigger than phi_0, which implies that the minimum
    # lies between a and c. Find it via bisection.
    return bisect!(ϕdϕ, alphas, values, slopes, ia, ic, phi_lim, display)
end

# HZ, stage U3 (with theta=0.5)
function bisect!(ϕdϕ,
                 alphas::AbstractArray{T},
                 values,
                 slopes,
                 ia::Integer,
                 ib::Integer,
                 phi_lim::Real,
                 display::Integer = 0) where T
    gphi = convert(T, NaN)
    a = alphas[ia]
    b = alphas[ib]
    # Debugging (HZ, conditions shown following U3)
    zeroT = convert(T, 0)
    @assert slopes[ia] < zeroT
    @assert values[ia] <= phi_lim
    @assert slopes[ib] < zeroT       # otherwise we wouldn't be here
    @assert values[ib] > phi_lim
    @assert b > a
    while b - a > eps(b)
        if display & BISECT > 0
            println("bisect: a = ", a, ", b = ", b, ", b - a = ", b - a)
        end
        d = (a + b) / convert(T, 2)
        phi_d, gphi = ϕdϕ(d)
        @assert isfinite(phi_d) && isfinite(gphi)

        push!(alphas, d)
        push!(values, phi_d)
        push!(slopes, gphi)

        id = length(alphas)
        if gphi >= zeroT
            return ia, id # replace b, return
        end
        if phi_d <= phi_lim
            a = d # replace a, but keep bisecting until dphi_b > 0
            ia = id
        else
            b = d
            ib = id
        end
    end
    return ia, ib
end

doublefloatstypes = [Double64, Double32, Double16]

@testset "Arbitrary precision - initial step guess: $T" for T in
    [Float32, Float64, BigFloat, doublefloatstypes...]

    f(x) = dot(x, x)
    function g!(out, x)
        out[:] = 2x
    end

    x = convert.(T, [-1, -1])
    df = NLSolversBase.OnceDifferentiable(f,g!,x)

    phi_0, grtmp = NLSolversBase.value_gradient!(df, x)
    @test !isnan(phi_0)
    @test phi_0 isa T
    @test !any(isnan, grtmp)
    @test grtmp isa Vector{T}
    p = -grtmp
    dphi_0 = dot(p, grtmp)
    @test !isnan(dphi_0)
    @test dphi_0 isa T

    function getstate()
        state = StateDummy(convert(T, 1),  x, similar(x), convert(T, NaN), p)
    end
    # Test HagerZhang I0
    ls = HagerZhang{T}()
    state = getstate()
    is = InitialHagerZhang{T}(α0 = convert(T, NaN))
    is(ls, state, phi_0, dphi_0, df)
    @test !isnan(state.alpha)
    @test state.alpha isa T
    @test ls.mayterminate[] == false

    # Test HagerZhang I12
    ls = HagerZhang{T}()
    state = getstate()
    is = InitialHagerZhang{T}(α0 = convert(T, 1))
    is(ls, state, phi_0, dphi_0, df)
    @test !isnan(state.alpha)
    @test state.alpha isa T
    @test ls.mayterminate[] == true

    # Test Static unscaled
    ls = HagerZhang{T}()
    state = getstate()
    is = InitialStatic{T}()
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == is.alpha
    @test !isnan(state.alpha)
    @test state.alpha isa T
    @test ls.mayterminate[] == false

    # Test Static scaled
    ls = HagerZhang{T}()
    state = getstate()
    is = InitialStatic{T}(alpha = convert(T, 0.5), scaled = true)
    is(ls, state, phi_0, dphi_0, df)
    @test !isnan(state.alpha)
    @test !isnan(state.alpha)
    @test state.alpha isa T
    @test ls.mayterminate[] == false

    # Test Previous
    ls = HagerZhang{T}()
    state = getstate()
    alpha = state.alpha
    ls.mayterminate[] = true
    is = InitialPrevious{T}()
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == alpha
    @test !isnan(state.alpha)
    @test state.alpha isa T
    @test ls.mayterminate[] == true

    # Test Previous NaN
    ls = HagerZhang{T}()
    state = getstate()
    state.alpha = convert(T, NaN)
    ls.mayterminate[] = true
    is = InitialPrevious{T}()
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == is.alpha
    @test state.alpha isa T
    @test ls.mayterminate[] == true

    # Test Quadratic NaN
    ls = HagerZhang{T}()
    state = getstate()
    is = InitialQuadratic{T}()
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == is.α0
    @test !isnan(state.alpha)
    @test ls.mayterminate[] == false

    # Test Quadratic
    ls = HagerZhang{T}()
    state = getstate()
    state.f_x_previous = 2*phi_0
    is = InitialQuadratic{T}(snap2one=(convert(T, 0.9),convert(T, Inf)))
    is(ls, state, phi_0, dphi_0, df)
    @test !isnan(state.alpha)
    @test ls.mayterminate[] == false

    # Test Quadratic snap2one
    ls = HagerZhang{T}()
    state = getstate()
    state.f_x_previous = 2*phi_0
    is = InitialQuadratic{T}(snap2one=(convert(T, 0.75),convert(T, Inf)))
    is(ls, state, phi_0, dphi_0, df)
    @test !isnan(state.alpha)
    @test ls.mayterminate[] == false

    # Test ConstantChange NaN
    ls = HagerZhang{T}()
    state = getstate()
    is = InitialConstantChange{T}()
    is(ls, state, phi_0, dphi_0, df)
    @test state.alpha == is.α0
    @test !isnan(state.alpha)
    @test ls.mayterminate[] == false

    # Test ConstantChange
    ls = HagerZhang{T}()
    state = getstate()
    is = InitialConstantChange{T}()
    is.dϕ_0_previous[] = convert(T, 0.1)*dphi_0
    is(ls, state, phi_0, dphi_0, df)
    @test !isnan(state.alpha)
    @test ls.mayterminate[] == false

    # Test ConstantChange snap2one
    ls = HagerZhang{T}()
    state = getstate()
    is = InitialConstantChange{T}(snap2one=(convert(T, 0.25),convert(T, 1)))
    is.dϕ_0_previous[] = convert(T, 0.1)*dphi_0
    is(ls, state, phi_0, dphi_0, df)
    @test !isnan(state.alpha)
    @test ls.mayterminate[] == false
end

# TODO: Implement safeguards


"""
`StrongWolfe`: This linesearch algorithm guarantees that the step length
satisfies the (strong) Wolfe conditions.
See Nocedal and Wright - Algorithms 3.5 and 3.6

This algorithm is mostly of theoretical interest, users should most likely
use `MoreThuente`, `HagerZhang` or `BackTracking`.

## Parameters:  (and defaults)
* `c_1 = 1e-4`: Armijo condition
* `c_2 = 0.9` : second (strong) Wolfe condition
* `ρ = 2.0` : bracket growth
"""
@kwdef struct StrongWolfe{T} <: AbstractLineSearch
    c_1::T = 1e-4
    c_2::T = 0.9
    ρ::T = 2.0
    cache::Union{Nothing,LineSearchCache{T}} = nothing
end

"""
    (ls::StrongWolfe)(df, x::AbstractArray, p::AbstractArray, alpha0::Real, x_new, ϕ_0, dϕ_0) -> alpha, ϕalpha

Given a differentiable function `df` (in the sense of `NLSolversBase.OnceDifferentiable` or
`NLSolversBase.TwiceDifferentiable`), a multidimensional starting point `x` and step `p`,
and a guess `alpha0` for the step length, find an `alpha` satisfying the strong Wolfe conditions.

See the one-dimensional method for additional details.
"""
function (ls::StrongWolfe)(df, x::AbstractArray{T},
                           p::AbstractArray{T}, α::Real, x_new::AbstractArray{T},
                           ϕ_0, dϕ_0) where T
    ϕ, dϕ, ϕdϕ = make_ϕ_dϕ_ϕdϕ(df, x_new, x, p)
    ls(ϕ, dϕ, ϕdϕ, α, ϕ_0, dϕ_0)
end

"""
    (ls::StrongWolfe)(ϕ, dϕ, ϕdϕ, alpha0, ϕ_0, dϕ_0) -> alpha, ϕalpha

Given `ϕ(alpha::Real)`, its derivative `dϕ`, a combined-evaluation function
`ϕdϕ(alpha) -> (ϕ(alpha), dϕ(alpha))`, and an initial guess `alpha0`,
identify a value of `alpha > 0` satisfying the strong Wolfe conditions.

`ϕ_0` and `dϕ_0` are the value and derivative, respectively, of `ϕ` at `alpha = 0.`

Both `alpha` and `ϕ(alpha)` are returned.
"""
function (ls::StrongWolfe)(ϕ, dϕ, ϕdϕ,
                           alpha0::T, ϕ_0, dϕ_0) where T<:Real
    (; c_1, c_2, ρ, cache) = ls
    emptycache!(cache)

    zeroT = convert(T, 0)
    pushcache!(cache, zeroT, ϕ_0, dϕ_0)

    # Step-sizes
    a_0 = zeroT
    a_iminus1 = a_0
    a_i = alpha0
    a_max = convert(T, 65536)

    # ϕ(alpha) = df.f(x + alpha * p)
    ϕ_a_iminus1 = ϕ_0
    ϕ_a_i = convert(T, NaN)

    # ϕ'(alpha) = dot(g(x + alpha * p), p)
    dϕ_a_i = convert(T, NaN)

    # Iteration counter
    i = 1

    while a_i < a_max
        ϕ_a_i = ϕ(a_i)
        pushcache!(cache, a_i, ϕ_a_i)

        # Test Wolfe conditions
        if (ϕ_a_i > ϕ_0 + c_1 * a_i * dϕ_0) ||
            (ϕ_a_i >= ϕ_a_iminus1 && i > 1)
            a_star = zoom(a_iminus1, a_i,
                          dϕ_0, ϕ_0,
                          ϕ, dϕ, ϕdϕ, cache)
            return a_star, ϕ(a_star)
        end

        dϕ_a_i = dϕ(a_i)
        if cache !== nothing
            push!(cache.slopes, dϕ_a_i)
        end

        # Check condition 2
        if abs(dϕ_a_i) <= -c_2 * dϕ_0
            return a_i, ϕ_a_i
        end

        # Check condition 3
        if dϕ_a_i >= zeroT # FIXME untested!
            a_star = zoom(a_i, a_iminus1,
                          dϕ_0, ϕ_0, ϕ, dϕ, ϕdϕ, cache)
            return a_star, ϕ(a_star)
        end

        # Choose a_iplus1 from the interval (a_i, a_max)
        a_iminus1 = a_i
        a_i *= ρ

        # Update ϕ_a_iminus1
        ϕ_a_iminus1 = ϕ_a_i

        # Update iteration count
        i += 1
    end

    # Quasi-error response TODO make this error instead
    return a_max, ϕ(a_max)
end

function zoom(a_lo::T,
              a_hi::T,
              dϕ_0::Real,
              ϕ_0::Real,
              ϕ,
              dϕ,
              ϕdϕ,
              cache,
              c_1::Real = convert(T, 1)/10^4,
              c_2::Real = convert(T, 9)/10) where T

    zeroT = convert(T, 0)
    # Step-size
    a_j = convert(T, NaN)

    # Count iterations
    iteration = 0
    max_iterations = 10

    # Shrink bracket
    while iteration < max_iterations
        iteration += 1

        ϕ_a_lo, ϕprime_a_lo = ϕdϕ(a_lo)
        pushcache!(cache, a_lo, ϕ_a_lo, ϕprime_a_lo)

        ϕ_a_hi, ϕprime_a_hi = ϕdϕ(a_hi)
        pushcache!(cache, a_hi, ϕ_a_hi, ϕprime_a_hi)

        # Interpolate a_j
        if a_lo < a_hi
            a_j = interpolate(a_lo, a_hi,
                              ϕ_a_lo, ϕ_a_hi,
                              ϕprime_a_lo, ϕprime_a_hi)
        else
            # TODO: Check if this is needed
            a_j = interpolate(a_hi, a_lo,
                              ϕ_a_hi, ϕ_a_lo,
                              ϕprime_a_hi, ϕprime_a_lo)
        end

        # Evaluate ϕ(a_j)
        ϕ_a_j = ϕ(a_j)
        pushcache!(cache, a_j, ϕ_a_j)

        # Check Armijo
        if (ϕ_a_j > ϕ_0 + c_1 * a_j * dϕ_0) ||
            (ϕ_a_j > ϕ_a_lo)
            a_hi = a_j
        else
            # Evaluate ϕprime(a_j)
            ϕprime_a_j = dϕ(a_j)
            if cache !== nothing
                push!(cache.slopes, ϕprime_a_j)
            end

            if abs(ϕprime_a_j) <= -c_2 * dϕ_0
                return a_j
            end

            if ϕprime_a_j * (a_hi - a_lo) >= zeroT
                a_hi = a_lo
            end

            a_lo = a_j
        end
    end

    # Quasi-error response
    return a_j
end

# a_lo = a_{i - 1}
# a_hi = a_{i}
function interpolate(a_i1::Real, a_i::Real,
                     ϕ_a_i1::Real, ϕ_a_i::Real,
                     dϕ_a_i1::Real, dϕ_a_i::Real)
    d1 = dϕ_a_i1 + dϕ_a_i -
        3 * (ϕ_a_i1 - ϕ_a_i) / (a_i1 - a_i)
    d2 = sqrt(d1 * d1 - dϕ_a_i1 * dϕ_a_i)
    return a_i - (a_i - a_i1) *
        ((dϕ_a_i + d2 - d1) /
         (dϕ_a_i - dϕ_a_i1 + 2 * d2))
end

module LineSearches

using Printf: @sprintf
using LinearAlgebra: dot, norm
using NaNMath: NaNMath
using NLSolversBase: NLSolversBase, AbstractObjective

export LineSearchException, LineSearchCache

export AbstractLineSearch, BackTracking, HagerZhang, Static, MoreThuente, StrongWolfe

export InitialHagerZhang, InitialStatic, InitialPrevious,
    InitialQuadratic, InitialConstantChange


function make_ϕ(df, x_new, x, s)
    function ϕ(α)
        # Move a distance of alpha in the direction of s
        x_new .= x .+ α.*s

        # Evaluate f(x+α*s)
        NLSolversBase.value!(df, x_new)
    end
    ϕ
end
function make_ϕdϕ(df, x_new, x, s)
    function ϕdϕ(α)
        # Move a distance of alpha in the direction of s
        x_new .= x .+ α.*s

        # Evaluate ∇f(x+α*s)
        f_x_new, g_x_new = NLSolversBase.value_gradient!(df, x_new)

        # Calculate ϕ(a_i), ϕ'(a_i)
        return f_x_new, real(dot(g_x_new, s))
    end
    ϕdϕ
end
function make_ϕ_dϕ(df, x_new, x, s)
    function dϕ(α)
        # Move a distance of alpha in the direction of s
        x_new .= x .+ α.*s

        # Evaluate ∇f(x+α*s)
        g_x_new = NLSolversBase.gradient!(df, x_new)

        # Calculate ϕ'(a_i)
        return real(dot(g_x_new, s))
    end
    make_ϕ(df, x_new, x, s), dϕ
end
function make_ϕ_dϕ_ϕdϕ(df, x_new, x, s)
    make_ϕ_dϕ(df, x_new, x, s)..., make_ϕdϕ(df, x_new, x, s)
end
function make_ϕ_ϕdϕ(df, x_new, x, s)
    make_ϕ(df, x_new, x, s), make_ϕdϕ(df, x_new, x, s)
end

include("types.jl")

# The following don't extend `empty!` and `push!` because we want implementations for `nothing`
# and that would be piracy
emptycache!(cache::LineSearchCache) = begin
    empty!(cache.alphas)
    empty!(cache.values)
    empty!(cache.slopes)
end
emptycache!(::Nothing) = nothing
pushcache!(cache::LineSearchCache, α, val, slope) = begin
    push!(cache.alphas, α)
    push!(cache.values, val)
    push!(cache.slopes, slope)
end
pushcache!(cache::LineSearchCache, α, val) = begin
    push!(cache.alphas, α)
    push!(cache.values, val)
end
pushcache!(::Nothing, α, val, slope) = nothing
pushcache!(::Nothing, α, val) = nothing

# Line Search Methods
include("backtracking.jl")
include("strongwolfe.jl")
include("morethuente.jl")
include("hagerzhang.jl") # Also includes InitialHagerZhang
include("static.jl")

# Initial guess methods
include("initialguess.jl")

include("deprecate.jl")

end # module

mutable struct LineSearchException{T<:Real} <: Exception
    message::AbstractString
    alpha::T
end

abstract type AbstractLineSearch end

# For debugging
struct LineSearchCache{T}
    alphas::Vector{T}
    values::Vector{T}
    slopes::Vector{T}
end
"""
    cache = LineSearchCache{T}()

Initialize an empty cache for storing intermediate results during line search.
The `α`, `ϕ(α)`, and possibly `dϕ(α)` values computed during line search are
available in `cache.alphas`, `cache.values`, and `cache.slopes`, respectively.

# Example

```jldoctest
julia> ϕ(x) = (x - π)^4; dϕ(x) = 4*(x-π)^3;

julia> cache = LineSearchCache{Float64}();

julia> ls = BackTracking(; cache);

julia> ls(ϕ, 10.0, ϕ(0), dϕ(0))
(1.8481462933284658, 2.7989406670901373)

julia> cache
LineSearchCache{Float64}([0.0, 10.0, 1.8481462933284658], [97.40909103400242, 2212.550050116452, 2.7989406670901373], [-124.02510672119926])
```

Because `BackTracking` doesn't use derivatives except at `α=0`, only the initial slope was stored in the cache.
Other methods may store all three.
"""
LineSearchCache{T}() where T = LineSearchCache{T}(T[], T[], T[])

#   Translation of Matlab version by John Myles White
#   Translation of minpack subroutine cvsrch
#   Dianne O'Leary   July 1991
#
#     **********
#
#     Subroutine cvsrch
#
#     The purpose of cvsrch is to find a step which satisfies
#     a sufficient decrease condition and a curvature condition.
#     The user must provide a subroutine which calculates the
#     function and the gradient.
#
#     At each stage the subroutine updates an interval of
#     uncertainty with endpoints stx and sty. The interval of
#     uncertainty is initially chosen so that it contains a
#     minimizer of the modified function
#
#          f(x + stp * s) - f(x) - f_tol * stp * (gradf(x)' * s).
#
#     If a step is obtained for which the modified function
#     has a nonpositive function value and nonnegative derivative,
#     then the interval of uncertainty is chosen so that it
#     contains a minimizer of f(x + stp * s).
#
#     The algorithm is designed to find a step which satisfies
#     the sufficient decrease condition
#
#           f(x + stp * s) <= f(x) + f_tol * stp * (gradf(x)' * s),
#
#     and the curvature condition
#
#           abs(gradf(x + stp * s)' * s)) <= gtol * abs(gradf(x)' * s).
#
#     If f_tol is less than gtol and if, for example, the function
#     is bounded below, then there is always a step which satisfies
#     both conditions. If no step can be found which satisfies both
#     conditions, then the algorithm usually stops when rounding
#     errors prevent further progress. In this case stp only
#     satisfies the sufficient decrease condition.
#
#     The subroutine statement is
#
#        subroutine cvsrch(df,n,x,f,s,stp,f_tol,gtol,x_tol,
#                          alphamin,alphamax,maxfev,info,nfev,wa)
#
#     where
#
# df is the name of the user-supplied subroutine which
#    calculates the function and the gradient.  df must
#    be declared in an external statement in the user
#    calling program, and should be written as follows.
#
#    function [f,g] = df(n,x) (Matlab)
#                     (10/2010 change in documentation)
#                     (derived from Fortran subroutine df(n,x,f,g))
#    integer n
#    f
#    x(n),g(n)
#
#    Calculate the function at x and
#    return this value in the variable f.
#    Calculate the gradient at x and
#    return this vector in g.
#
#  n is a positive integer input variable set to the number
#   of variables.
#
# x is an Abstractarray of length n. On input it must contain the
#   base point for the line search. On output it contains
#    x + stp * s.
#
# f is a variable. On input it must contain the value of f
#    at x. On output it contains the value of f at x + stp * s.
#
# g is an Abstractarray of length n. On input it must contain the
#    gradient of f at x. On output it contains the gradient
#    of f at x + stp * s.
#
# s is an input Abstractarray of length n which specifies the
#    search direction.
#
# stp is a nonnegative variable. On input stp contains an
#    initial estimate of a satisfactory step. On output
#    stp contains the final estimate.
#
#  f_tol and gtol are nonnegative input variables. Termination
#    occurs when the sufficient decrease condition and the
#    directional derivative condition are satisfied.
#
# x_tol is a nonnegative input variable. Termination occurs
#    when the relative width of the interval of uncertainty
#   is at most x_tol.
#
# alphamin and alphamax are nonnegative input variables which
#   specify lower and upper bounds for the step.
#
# maxfev is a positive integer input variable. Termination
#    occurs when the number of calls to df is at least
#    maxfev by the end of an iteration.
#
# info is an integer output variable set as follows:
#
#   info = 0  Improper input parameters.
#
#   info = 1  The sufficient decrease condition and the
#              directional derivative condition hold.
#
#   info = 2  Relative width of the interval of uncertainty
#            is at most x_tol.
#
#   info = 3  Number of calls to df has reached maxfev.
#
#   info = 4  The step is at the lower bound alphamin.
#
#   info = 5  The step is at the upper bound alphamax.
#
#   info = 6  Rounding errors prevent further progress.
#              There may not be a step which satisfies the
#              sufficient decrease and curvature conditions.
#              Tolerances may be too small.
#
#    nfev is an integer output variable set to the number of
#         calls to df.
#
#     Argonne National Laboratory. MINPACK Project. June 1983
#     Jorge J. More', David J. Thuente
#
#     **********

# Returns x, f, stp, info, nfev
# TODO: Decide whether to update x, f, g and info
#       or just return step and nfev and let existing code do its job

"""
The line search implementation from:
  Moré, Jorge J., and David J. Thuente
    Line search algorithms with guaranteed sufficient decrease.
    ACM Transactions on Mathematical Software (TOMS) 20.3 (1994): 286-307.
"""
@kwdef struct MoreThuente{T} <: AbstractLineSearch
    f_tol::T = 1e-4 # c_1 Wolfe sufficient decrease condition
    gtol::T = 0.9   # c_2 Wolfe curvature condition (Recommend 0.1 for GradientDescent)
    x_tol::T = 1e-8
    alphamin::T = 1e-16
    alphamax::T = 65536.0
    maxfev::Int = 100
    cache::Union{Nothing,LineSearchCache{T}} = nothing
end

function (ls::MoreThuente)(df::AbstractObjective, x::AbstractArray{T},
                           s::AbstractArray{T}, alpha::Real, x_new::AbstractArray{T},
                           ϕ_0, dϕ_0) where T
    ϕdϕ = make_ϕdϕ(df, x_new, x, s)
    ls(ϕdϕ, alpha, ϕ_0, dϕ_0)
end

(ls::MoreThuente)(ϕ, dϕ, ϕdϕ, alpha, ϕ_0, dϕ_0) = ls(ϕdϕ, alpha, ϕ_0, dϕ_0)

# TODO: Should we deprecate the interface that only uses the ϕdϕ argument?
function (ls::MoreThuente)(ϕdϕ,
                           alpha::T,
                           ϕ_0,
                           dϕ_0) where T
    (; f_tol, gtol, x_tol, alphamin, alphamax, maxfev, cache) = ls
    emptycache!(cache)

    iterfinitemax = -log2(eps(T))
    info = 0
    info_cstep = 1 # Info from step

    zeroT = convert(T, 0)
    pushcache!(cache, zeroT, ϕ_0, dϕ_0)

    #
    # Check the input parameters for errors.
    #

    if  alpha <= zeroT || f_tol < zeroT || gtol < zeroT ||
        x_tol < zeroT || alphamin < zeroT || alphamax < alphamin || maxfev <= zeroT
        throw(LineSearchException("Invalid parameters to MoreThuente.", 0))
    end

    if dϕ_0 >= zeroT
        throw(LineSearchException("Search direction is not a direction of descent.", 0))
    end

    #
    # Initialize local variables.
    #

    bracketed = false
    stage1 = true
    nfev = 0
    finit = ϕ_0
    dgtest = f_tol * dϕ_0
    width = alphamax - alphamin
    width1 = 2 * width

    # Keep this across calls

    #
    # The variables stx, fx, dgx contain the values of the step,
    # function, and directional derivative at the best step.
    # The variables sty, fy, dgy contain the value of the step,
    # function, and derivative at the other endpoint of
    # the interval of uncertainty.
    # The variables alpha, f, dg contain the values of the step,
    # function, and derivative at the current step.
    #

    stx = zeroT
    fx = finit
    dgx = dϕ_0
    sty = zeroT
    fy = finit
    dgy = dϕ_0

    # START: Ensure that the initial step provides finite function values
    # This is not part of the original FORTRAN code
    if !isfinite(alpha)
        alpha = one(T)
    end
    stmin = stx
    stmax = alpha + 4 * (alpha - stx) # Why 4?
    alpha = max(alpha, alphamin)
    alpha = min(alpha, alphamax)

    f, dg = ϕdϕ(alpha)
    nfev += 1 # This includes calls to f() and g!()
    iterfinite = 0
    while (!isfinite(f) || !isfinite(dg)) && iterfinite < iterfinitemax
        iterfinite += 1
        alpha = alpha/2

        f, dg = ϕdϕ(alpha)
        nfev += 1 # This includes calls to f() and g!()

        # Make stmax = (3/2)*alpha < 2alpha in the first iteration below
        stx = (convert(T, 7)/8)*alpha
    end
    pushcache!(cache, alpha, f, dg)
    # END: Ensure that the initial step provides finite function values
    # TODO: check if value is finite (maybe iterfinite > iterfinitemax)

    while true
        #
        # Set the minimum and maximum steps to correspond
        # to the present interval of uncertainty.
        #

        if bracketed
            stmin = min(stx, sty)
            stmax = max(stx, sty)
        else
            stmin = stx
            stmax = alpha + 4 * (alpha - stx) # Why 4?
        end

        #
        # Ensure stmin and stmax (used in cstep) don't violate alphamin and alphamax
        # Not part of original FORTRAN translation
        #
        stmin = max(alphamin,stmin)
        stmax = min(alphamax,stmax)

        #
        # Force the step to be within the bounds alphamax and alphamin
        #

        alpha = max(alpha, alphamin)
        alpha = min(alpha, alphamax)

        #
        # If an unusual termination is to occur then let
        # alpha be the lowest point obtained so far.
        #

        if (bracketed && (alpha <= stmin || alpha >= stmax)) ||
            nfev >= maxfev-1 || info_cstep == 0 ||
            (bracketed && stmax - stmin <= x_tol * stmax)
            alpha = stx
        end

        #
        # Evaluate the function and gradient at alpha
        # and compute the directional derivative.
        #
        f, dg = ϕdϕ(alpha)
        pushcache!(cache, alpha, f, dg)
        nfev += 1 # This includes calls to f() and g!()

        if isapprox(dg, 0, atol=eps(T)) # Should add atol value to MoreThuente
            return alpha, f
        end

        ftest1 = finit + alpha * dgtest

        #
        # Test for convergence.
        #

        # What does info_cstep stand for?

        if (bracketed && (alpha <= stmin || alpha >= stmax)) || info_cstep == 0
            info = 6
        end
        if alpha == alphamax && f <= ftest1 && dg <= dgtest
            info = 5
        end
        if alpha == alphamin && (f > ftest1 || dg >= dgtest)
            info = 4
        end
        if nfev >= maxfev
            info = 3
        end
        if bracketed && stmax - stmin <= x_tol * stmax
            info = 2
        end
        if f <= ftest1 && abs(dg) <= -gtol * dϕ_0
            info = 1
        end

        #
        # Check for termination.
        #

        if info != 0
            return alpha, f
        end

        #
        # In the first stage we seek a step for which the modified
        # function has a nonpositive value and nonnegative derivative.
        #

        if stage1 && f <= ftest1 && dg >= min(f_tol, gtol) * dϕ_0
            stage1 = false
        end

        #
        # A modified function is used to predict the step only if
        # we have not obtained a step for which the modified
        # function has a nonpositive function value and nonnegative
        # derivative, and if a lower function value has been
        # obtained but the decrease is not sufficient.
        #

        if stage1 && f <= fx && f > ftest1
            #
            # Define the modified function and derivative values.
            #
            fm = f - alpha * dgtest
            fxm = fx - stx * dgtest
            fym = fy - sty * dgtest
            dgm = dg - dgtest
            dgxm = dgx - dgtest
            dgym = dgy - dgtest
            #
            # Call cstep to update the interval of uncertainty
            # and to compute the new step.
            #
            stx, fxm, dgxm,
            sty, fym, dgym,
            alpha, fm, dgm,
            bracketed, info_cstep =
                cstep(stx, fxm, dgxm, sty, fym, dgym,
                      alpha, fm, dgm, bracketed, stmin, stmax)
            #
            # Reset the function and gradient values for f.
            #
            fx = fxm + stx * dgtest
            fy = fym + sty * dgtest
            dgx = dgxm + dgtest
            dgy = dgym + dgtest
        else
            #
            # Call cstep to update the interval of uncertainty
            # and to compute the new step.
            #
            stx, fx, dgx,
            sty, fy, dgy,
            alpha, f, dg,
            bracketed, info_cstep =
                cstep(stx, fx, dgx, sty, fy, dgy,
                      alpha, f, dg, bracketed, stmin, stmax)
        end

        #
        # Force a sufficient decrease in the size of the
        # interval of uncertainty.
        #

        if bracketed
            if abs(sty - stx) >= (convert(T, 2)/3) * width1
                alpha = stx + (sty - stx)/2
            end
            width1 = width
            width = abs(sty - stx)
        end
    end # while
end # function


# Translation of minpack subroutine cstep
# Dianne O'Leary   July 1991
#
# Subroutine cstep
#
# The purpose of cstep is to compute a safeguarded step for
# a linesearch and to update an interval of uncertainty for
# a minimizer of the function.
#
# The parameter stx contains the step with the least function
# value. The parameter stp contains the current step. It is
# assumed that the derivative at stx is negative in the
# direction of the step. If bracketed is set true then a
# minimizer has been bracketed in an interval of uncertainty
# with endpoints stx and sty.
#
# The subroutine statement is
#
# subroutine cstep(stx, fx, dgx,
#                  sty, fy, dgy,
#                  stp, f, dg,
#                  bracketed, alphamin, alphamax, info)
#
# where
#
# stx, fx, and dgx are variables which specify the step,
#   the function, and the derivative at the best step obtained
#   so far. The derivative must be negative in the direction
#   of the step, that is, dgx and stp-stx must have opposite
#   signs. On output these parameters are updated appropriately
#
# sty, fy, and dgy are variables which specify the step,
#   the function, and the derivative at the other endpoint of
#   the interval of uncertainty. On output these parameters are
#   updated appropriately
#
# stp, f, and dg are variables which specify the step,
#   the function, and the derivative at the current step.
#   If bracketed is set true then on input stp must be
#   between stx and sty. On output stp is set to the new step
#
# bracketed is a logical variable which specifies if a minimizer
#   has been bracketed. If the minimizer has not been bracketed
#   then on input bracketed must be set false. If the minimizer
#   is bracketed then on output bracketed is set true
#
# alphamin and alphamax are input variables which specify lower
#   and upper bounds for the step
#
# info is an integer output variable set as follows:
#   If info = 1,2,3,4,5, then the step has been computed
#   according to one of the five cases below. Otherwise
#   info = 0, and this indicates improper input parameters
#
# Argonne National Laboratory. MINPACK Project. June 1983
# Jorge J. More', David J. Thuente

function cstep(stx::Real, fx::Real, dgx::Real,
               sty::Real, fy::Real, dgy::Real,
               alpha::Real, f::Real, dg::Real,
               bracketed::Bool, alphamin::Real, alphamax::Real)

   T = promote_type(typeof(stx), typeof(fx), typeof(dgx), typeof(sty), typeof(fy), typeof(dgy), typeof(alpha), typeof(f), typeof(dg), typeof(alphamin), typeof(alphamax))
   zeroT = convert(T, 0)
   info = 0

   #
   # Check the input parameters for error
   #

   if (bracketed && (alpha <= min(stx, sty) || alpha >= max(stx, sty))) ||
     dgx * (alpha - stx) >= zeroT || alphamax < alphamin
       throw(ArgumentError("Minimizer not bracketed"))
   end

   #
   # Determine if the derivatives have opposite sign
   #

   sgnd = dg * (dgx / abs(dgx))

   #
   # First case. A higher function value.
   # The minimum is bracketed. If the cubic step is closer
   # to stx than the quadratic step, the cubic step is taken,
   # else the average of the cubic and quadratic steps is taken
   #

   if f > fx
      info = 1
      bound = true
      theta = 3 * (fx - f) / (alpha - stx) + dgx + dg
      # Use s to prevent overflow/underflow of theta^2 and dgx * dg
      s = max(abs(theta), abs(dgx), abs(dg))
      gamma = s * sqrt((theta / s)^2 - (dgx / s) * (dg / s))
      if alpha < stx
          gamma = -gamma
      end
      p = gamma - dgx + theta
      q = gamma - dgx + gamma + dg
      r = p / q
      alphac = stx + r * (alpha - stx)
      alphaq = stx + (dgx / ((fx - f) / (alpha - stx) + dgx)) / 2 * (alpha - stx)
      if abs(alphac - stx) < abs(alphaq - stx)
         alphaf = alphac
      else
         alphaf = (alphac + alphaq) / 2
      end
      bracketed = true

   #
   # Second case. A lower function value and derivatives of
   # opposite sign. The minimum is bracketed. If the cubic
   # step is closer to stx than the quadratic (secant) step,
   # the cubic step is taken, else the quadratic step is taken
   #

elseif sgnd < zeroT
      info = 2
      bound = false
      theta = 3 * (fx - f) / (alpha - stx) + dgx + dg
      # Use s to prevent overflow/underflow of theta^2 and dgx * dg
      s = max(abs(theta), abs(dgx), abs(dg))
      gamma = s * sqrt((theta / s)^2 - (dgx / s) * (dg / s))

      if alpha > stx
         gamma = -gamma
      end
      p = gamma - dg + theta
      q = gamma - dg + gamma + dgx
      r = p / q
      alphac = alpha + r * (stx - alpha)
      alphaq = alpha + (dg / (dg - dgx)) * (stx - alpha)
      if abs(alphac - alpha) > abs(alphaq - alpha)
         alphaf = alphac
      else
         alphaf = alphaq
      end
      bracketed = true

   #
   # Third case. A lower function value, derivatives of the
   # same sign, and the magnitude of the derivative decreases.
   # The cubic step is only used if the cubic tends to infinity
   # in the direction of the step or if the minimum of the cubic
   # is beyond alpha. Otherwise the cubic step is defined to be
   # either alphamin or alphamax. The quadratic (secant) step is also
   # computed and if the minimum is bracketed then the the step
   # closest to stx is taken, else the step farthest away is taken
   #

   elseif abs(dg) < abs(dgx)
      info = 3
      bound = true
      theta = 3 * (fx - f) / (alpha - stx) + dgx + dg
      # Use s to prevent overflow/underflow of theta^2 and dgx * dg
      s = max(abs(theta), abs(dgx), abs(dg))
      #
      # The case gamma = 0 only arises if the cubic does not tend
      # to infinity in the direction of the step
      #
      # # Use NaNMath in case s == zero(s)
      gamma = s * sqrt(NaNMath.max(zero(s), (theta / s)^2 - (dgx / s) * (dg / s)))

      if alpha > stx
          gamma = -gamma
      end
      p = gamma - dg + theta
      q = gamma + dgx - dg + gamma
      r = p / q
      if r < zeroT && gamma != zeroT
         alphac = alpha + r * (stx - alpha)
     elseif alpha > stx
         alphac = alphamax
      else
         alphac = alphamin
      end
      alphaq = alpha + (dg / (dg - dgx)) * (stx - alpha)
      if bracketed
         if abs(alpha - alphac) < abs(alpha - alphaq)
            alphaf = alphac
         else
            alphaf = alphaq
         end
      else
         if abs(alpha - alphac) > abs(alpha - alphaq)
            alphaf = alphac
         else
            alphaf = alphaq
         end
      end

   #
   # Fourth case. A lower function value, derivatives of the
   # same sign, and the magnitude of the derivative does
   # not decrease. If the minimum is not bracketed, the step
   # is either alphamin or alphamax, else the cubic step is taken
   #

   else
      info = 4
      bound = false
      if bracketed
         theta = 3 * (f - fy) / (sty - alpha) + dgy + dg
         # Use s to prevent overflow/underflow of theta^2 and dgy * dg
         s = max(abs(theta), abs(dgy), abs(dg))
         gamma = s * sqrt((theta / s)^2 - (dgy / s) * (dg / s))

         if alpha > sty
             gamma = -gamma
         end
         p = gamma - dg + theta
         q = gamma - dg + gamma + dgy
         r = p / q
         alphac = alpha + r * (sty - alpha)
         alphaf = alphac
     elseif alpha > stx
         alphaf = alphamax
      else
         alphaf = alphamin
      end
   end

   #
   # Update the interval of uncertainty. This update does not
   # depend on the new step or the case analysis above
   #

   if f > fx
      sty = alpha
      fy = f
      dgy = dg
   else
      if sgnd < zeroT
         sty = stx
         fy = fx
         dgy = dgx
      end
      stx = alpha
      fx = f
      dgx = dg
   end

   #
   # Compute the new step and safeguard it
   #

   alphaf = min(alphamax, alphaf)
   alphaf = max(alphamin, alphaf)
   alpha = alphaf
   if bracketed && bound
      if sty > stx
         alpha = min(stx + (convert(T, 2)/3) * (sty - stx), alpha)
      else
         alpha = max(stx + (convert(T, 2)/3) * (sty - stx), alpha)
      end
   end

   return stx, fx, dgx, sty, fy, dgy, alpha, f, dg, bracketed, info
end

using LineSearches
using Test
using LinearAlgebra: norm, dot
using OptimTestProblems
using DoubleFloats: Double64, Double32, Double16
import NLSolversBase

debug_printing = false

lstypes =  (Static(), HagerZhang(), StrongWolfe(), MoreThuente(),
            BackTracking(), BackTracking(order=2) )

my_tests = [
    "initial.jl",
    "alphacalc.jl",
    "arbitrary_precision.jl",
    "examples.jl",
    "captured.jl",
    "issues.jl",
    "qa.jl",
]

mutable struct StateDummy
    alpha
    x
    x_ls
    f_x_previous
    s
end

for my_test in my_tests
    println("\n * $(my_test)")
    @time include(my_test)
end

@testset "External constructors" begin
    bt = BackTracking{Float32}()
    @test typeof(bt) == BackTracking{Float32, Int}

    hz = HagerZhang{Float32}()
    @test typeof(hz) == HagerZhang{Float32, Base.RefValue{Bool}}
end

# https://github.com/JuliaNLSolvers/LineSearches.jl/issues/151
using LineSearches, LinearAlgebra, Test

A = randn(100, 100)
x0 = randn(100)
b = A * x0

# Objective function and gradient
f(x) = 0.5 * norm(A * x - b)^2
g!(gvec, x) = (gvec .= A' * (A * x - b))
fg!(gvec, x) = (g!(gvec, x); return f(x))

# Init
x = 1.0f1 * randn(100)
gv = similar(x)

# Line search
α0 = 1.0f-3
ϕ0 = fg!(gv, x)
s = -1 * gv
dϕ0 = dot(gv, s)
println(ϕ0, ", ", dϕ0)

# Univariate line search functions
ϕ(α) = f(x .+ α .* s)
function dϕ(α)
    g!(gv, x .+ α .* s)
    return dot(gv, s)
end
function ϕdϕ(α)
    phi = fg!(gv, x .+ α .* s)
    dphi = dot(gv, s)
    return (phi, dphi)
end

res = (StrongWolfe())(ϕ, dϕ, ϕdϕ, α0, ϕ0, dϕ0)
@test res[2] > 0
@test res[2] == ϕ(res[1])

@testset "HZ convergence issues" begin
    @testset "Flatness check issues" begin
        function prepare_test_case(; alphas, values, slopes)
            perm = sortperm(alphas)
            alphas = alphas[perm]
            push!(alphas, alphas[end] + 1)
            values = values[perm]
            push!(values, values[end])
            slopes = slopes[perm]
            push!(slopes, 0.0)
            return LineSearchTestCase(alphas, values, slopes)
        end

        tc1 = prepare_test_case(;
            alphas = [0.0, 1.0, 5.0, 3.541670844449739],
            values = [
                3003.592409634743,
                2962.0378569864743,
                2891.4462095232184,
                3000.9760725116876,
            ],
            slopes = [
                -22332.321416890798,
                -20423.214551925797,
                11718.185026267562,
                -22286.821227217057,
            ],
        )

        function tc_to_f(tc)
            function f(x)
                i = findfirst(u -> u > x, tc.alphas) - 1
                xk = tc.alphas[i]
                xkp1 = tc.alphas[i+1]
                dx = xkp1 - xk
                t = (x - xk) / dx
                h00t = 2t^3 - 3t^2 + 1
                h10t = t * (1 - t)^2
                h01t = t^2 * (3 - 2t)
                h11t = t^2 * (t - 1)
                val =
                    h00t * tc.values[i] +
                    h10t * dx * tc.slopes[i] +
                    h01t * tc.values[i+1] +
                    h11t * dx * tc.slopes[i+1]

                return val
            end
        end
        function tc_to_fdf(tc)
            function fdf(x)
                i = findfirst(u -> u > x, tc.alphas) - 1
                xk = tc.alphas[i]
                xkp1 = tc.alphas[i+1]
                dx = xkp1 - xk
                t = (x - xk) / dx
                h00t = 2t^3 - 3t^2 + 1
                h10t = t * (1 - t)^2
                h01t = t^2 * (3 - 2t)
                h11t = t^2 * (t - 1)
                val =
                    h00t * tc.values[i] +
                    h10t * dx * tc.slopes[i] +
                    h01t * tc.values[i+1] +
                    h11t * dx * tc.slopes[i+1]

                h00tp = 6t^2 - 6t
                h10tp = 3t^2 - 4t + 1
                h01tp = -6t^2 + 6 * t
                h11tp = 3t^2 - 2t
                slope =
                    (
                        h00tp * tc.values[i] +
                        h10tp * dx * tc.slopes[i] +
                        h01tp * tc.values[i+1] +
                        h11tp * dx * tc.slopes[i+1]
                    ) / dx
                println(x, " ", val, " ", slope)
                return val, slope
            end
        end

        function test_tc(tc, check_flatness)
            cache = LineSearchCache{Float64}()
            hz = HagerZhang(; cache, check_flatness)
            f = tc_to_f(tc)
            fdf = tc_to_fdf(tc)
            hz(f, fdf, 1.0, fdf(0.0)...), cache
        end

        res, res_cache = test_tc(tc1, true)
        @show res
        @show res_cache
        @test_broken minimum(res_cache.values) == res[2]

        res2, res_cache2 = test_tc(tc1, false)
        @test minimum(res_cache2.values) == res2[2]
        #=
        using AlgebraOfGraphics, CairoMakie
        draw(data((x=0.0:0.05:5.5, y=map(x->tc_to_f(tc1)(x), 0:0.05:5.5)))*mapping(:x,:y)*visual(Scatter)+
        data((alphas=res_cache.alphas, values=res_cache.values))*mapping(:alphas,:values)*visual(Scatter; color=:red))
        =#
    end

    # should add as upstream
    #=
    @testset "from kbarros" begin
        # The minimizer is x0=[0, 2πn/100], with f(x0) = 1. Any integer n is fine.
        function f(x)
            return (x[1]^2 + 1) * (2 - cos(100*x[2]))
        end

        using Optim

        function test_converges(method)
            for i in 1:100
                r = randn(2)
                res = optimize(f, r, method)
                if Optim.converged(res) && minimum(res) > f([0,0]) + 1e-8
                    println("""
                        Incorrectly reported convergence after $(res.iterations) iterations
                        Reached x = $(Optim.minimizer(res)) with f(x) = $(minimum(res))
                        """)
                end
            end
        end

        # Works successfully, no printed output
        test_converges(LBFGS(; linesearch=Optim.LineSearches.BackTracking(order=2)))

        # Prints ~10 failures to converge (in 100 tries). Frequently fails after the
        # first line search.
        test_converges(ConjugateGradient(; linesearch=Optim.LineSearches.HagerZhang(check_flatness=false)))
    end
    =#
end

"""
`BackTracking` specifies a backtracking line-search that uses
a quadratic or cubic interpolant to determine the reduction in step-size.
E.g.,
if f(α) > f(0) + c₁ α f'(0), then the quadratic interpolant of
f(0), f'(0), f(α) has a minimiser α' in the open interval (0, α). More strongly,
there exists a factor ρ = ρ(c₁) such that α' ≦ ρ α.

This is a modification of the algorithm described in Nocedal Wright (2nd ed), Sec. 3.5.
"""
@kwdef struct BackTracking{TF, TI} <: AbstractLineSearch
    c_1::TF = 1e-4
    ρ_hi::TF = 0.5
    ρ_lo::TF = 0.1
    iterations::TI = 1_000
    order::TI = 3
    maxstep::TF = Inf
    cache::Union{Nothing,LineSearchCache{TF}} = nothing
end
BackTracking{TF}(args...; kwargs...) where TF = BackTracking{TF,Int}(args...; kwargs...)

function (ls::BackTracking)(df::AbstractObjective, x::AbstractArray{T}, s::AbstractArray{T},
                            α_0::Tα = real(T)(1), x_new::AbstractArray{T} = similar(x), ϕ_0 = nothing, dϕ_0 = nothing, alphamax = convert(real(T), Inf)) where {T, Tα}
    ϕ, dϕ = make_ϕ_dϕ(df, x_new, x, s)

    if ϕ_0 == nothing
        ϕ_0 = ϕ(Tα(0))
    end
    if dϕ_0 == nothing
        dϕ_0 = dϕ(Tα(0))
    end

    α_0 = min(α_0, min(alphamax, ls.maxstep / norm(s, Inf)))
    ls(ϕ, α_0, ϕ_0, dϕ_0)
end

(ls::BackTracking)(ϕ, dϕ, ϕdϕ, αinitial, ϕ_0, dϕ_0) = ls(ϕ, αinitial, ϕ_0, dϕ_0)

# TODO: Should we deprecate the interface that only uses the ϕ argument?
function (ls::BackTracking)(ϕ, αinitial::Tα, ϕ_0, dϕ_0) where Tα
    (; c_1, ρ_hi, ρ_lo, iterations, order, cache) = ls
    emptycache!(cache)
    pushcache!(cache, 0, ϕ_0, dϕ_0)  # backtracking doesn't use the slope except here

    iterfinitemax = -log2(eps(real(Tα)))

    @assert order in (2,3)
    # Check the input is valid, and modify otherwise
    #backtrack_condition = 1.0 - 1.0/(2*ρ) # want guaranteed backtrack factor
    #if c_1 >= backtrack_condition
    #    warn("""The Armijo constant c_1 is too large; replacing it with
    #                   $(backtrack_condition)""")
    #   c_1 = backtrack_condition
    #end

    # Count the total number of iterations
    iteration = 0

    ϕx_0, ϕx_1 = ϕ_0, ϕ_0

    α_1, α_2 = αinitial, αinitial

    ϕx_1 = ϕ(α_1)

    # Hard-coded backtrack until we find a finite function value
    iterfinite = 0
    while !isfinite(ϕx_1) && iterfinite < iterfinitemax
        iterfinite += 1
        α_1 = α_2
        α_2 = α_1/2

        ϕx_1 = ϕ(α_2)
    end
    pushcache!(cache, αinitial, ϕx_1)
    # TODO: check if value is finite (maybe iterfinite > iterfinitemax)

    # Backtrack until we satisfy sufficient decrease condition
    while ϕx_1 > ϕ_0 + c_1 * α_2 * dϕ_0
        # Increment the number of steps we've had to perform
        iteration += 1

        # Ensure termination
        if iteration > iterations
            throw(LineSearchException("Linesearch failed to converge, reached maximum iterations $(iterations).",
                                      α_2))
        end

        # Shrink proposed step-size:
        if order == 2 || iteration == 1
            # backtracking via quadratic interpolation:
            # This interpolates the available data
            #    f(0), f'(0), f(α)
            # with a quadractic which is then minimised; this comes with a
            # guaranteed backtracking factor 0.5 * (1-c_1)^{-1} which is < 1
            # provided that c_1 < 1/2; the backtrack_condition at the beginning
            # of the function guarantees at least a backtracking factor ρ.
            α_tmp = - (dϕ_0 * α_2^2) / ( 2 * (ϕx_1 - ϕ_0 - dϕ_0*α_2) )
        else
            div = one(Tα) / (α_1^2 * α_2^2 * (α_2 - α_1))
            a = (α_1^2*(ϕx_1 - ϕ_0 - dϕ_0*α_2) - α_2^2*(ϕx_0 - ϕ_0 - dϕ_0*α_1))*div
            b = (-α_1^3*(ϕx_1 - ϕ_0 - dϕ_0*α_2) + α_2^3*(ϕx_0 - ϕ_0 - dϕ_0*α_1))*div

            if isapprox(a, zero(a), atol=eps(real(Tα)))
                α_tmp = dϕ_0 / (2*b)
            else
                # discriminant
                d = max(b^2 - 3*a*dϕ_0, Tα(0))
                # quadratic equation root
                α_tmp = (-b + sqrt(d)) / (3*a)
            end
        end

        α_1 = α_2

        α_tmp = NaNMath.min(α_tmp, α_2*ρ_hi) # avoid too small reductions
        α_2 = NaNMath.max(α_tmp, α_2*ρ_lo) # avoid too big reductions

        # Evaluate f(x) at proposed position
        ϕx_0, ϕx_1 = ϕx_1, ϕ(α_2)
        pushcache!(cache, α_2, ϕx_1)
    end

    return α_2, ϕx_1
end

# Provide functionality for initial guesses to the step length

"""
Provide static initial step length.

Keyword `alpha` corresponds to static step length, default is 1.0.
If keyword `scaled = true`, then the initial step length
is scaled with the `l_2` norm of the step direction.
"""
@kwdef struct InitialStatic{T}
    alpha::T = 1.0
    scaled::Bool = false # Scales step. alpha ← min(alpha,||s||_2) / ||s||_2
end

function (is::InitialStatic{T})(ls, state, phi_0, dphi_0, df) where T
    PT = promote_type(T, real(eltype(state.s)))
    if is.scaled == true && (ns = real(norm(state.s))) > convert(PT, 0)
        # TODO: Type instability if there's a type mismatch between is.alpha and ns?
        state.alpha = convert(PT, min(is.alpha, ns)) / ns
    else
        state.alpha = convert(PT, is.alpha)
    end
end

"""
Use previous step length as initial guess,
within the bounds [alphamin, alphamax]


If state.alpha is NaN, then return fallback value is.alpha
"""
@kwdef struct InitialPrevious{T}
    alpha::T = 1.0
    alphamin::T = 0.0
    alphamax::T = Inf
end

function (is::InitialPrevious)(ls, state, phi_0, dphi_0, df)
    if isnan(state.alpha)
        state.alpha = is.alpha
    end
    state.alpha = min(is.alphamax, state.alpha)
    state.alpha = max(is.alphamin, state.alpha)
end



"""
Quadratic interpolation for initial step length guess.

This is meant for methods that do not produce well-scaled search directions,
such as Gradient Descent and (variations of) Conjugate Gradient methods.
See the discussion around Nocedal and Wright, 2nd ed, (3.60).

This procedure have several arguments, with the following defaults.
- `α0       = 1.0`.         The initial step size at the first iteration.
- `αmin     = 1e-12`.       The minimum initial step size. (Default arbitrary).
- `αmax     = 1.0`.         The maximum initial step size.
- `ρ        = 0.25`.        Maximum decrease from previous iteration, `αinit ≥ α_{k-1}`. (Default arbitrary).
- `snap2one = (0.75, Inf)`. Set all values within this (closed) interval to 1.0. (Default arbitrary).

If αmax ≠ 1.0, then you should consider to ensure that snap2one[2] < αmax.
"""
@kwdef struct InitialQuadratic{T}
    αmin::T = 1e-12 # Minimum initial step size (value somewhat arbitrary)
    αmax::T = 1.0   # Maximum initial step size (advised by Nocedal+Wright)
    α0::T   = 1.0   # Fallback at first iteration
    ρ::T    = 0.25  # maximum decrease from previous step (value somewhat arbitrary)
    snap2one::Tuple{T,T} = (0.75, Inf) # Set everything in this (closed) interval to 1.0
end

function (is::InitialQuadratic{T})(ls, state, phi_0, dphi_0, df) where T
    if !isfinite(state.f_x_previous) || isapprox(dphi_0, convert(T, 0), atol=eps(T)) # Need to add a tolerance
        # If we're at the first iteration
        αguess = is.α0
    else
        αguess = 2 * (phi_0 - state.f_x_previous) / dphi_0
        αguess = NaNMath.max(is.αmin, state.alpha*is.ρ, αguess)
        αguess = NaNMath.min(is.αmax, αguess)
        # if αguess ≈ 1, then make it 1 (Newton-type behaviour)
        if is.snap2one[1] ≤ αguess ≤ is.snap2one[2]
            αguess = one(state.alpha)
        end
    end
    state.alpha = αguess
end

"""
Constant first-order change approximation to determine initial step length.

** This requires that the optimization algorithm stores dphi0 from the previous iteration **
(dphi0_previous = real(dot(∇f_{k-1}, s_{k-1})), where s is the step direction.

This is meant for methods that do not produce well-scaled search directions,
such as Gradient Descent and (variations of) Conjugate Gradient methods.
See the discussion in Nocedal and Wright, 2nd ed, p. 59 on "Initial Step Length"

This procedure have several arguments, with the following defaults.
- `α0       = 1.0`.         The initial step size at the first iteration.
- `αmin     = 1e-12`.       The minimum initial step size. (Default arbitrary).
- `αmax     = 1.0`.         The maximum initial step size.
- `ρ        = 0.25`.        Maximum decrease from previous iteration, `αinit ≥ α_{k-1}`. (Default arbitrary).
- `snap2one = (0.75, Inf)`. Set all values within this (closed) interval to 1.0. (Default arbitrary).

If αmax ≠ 1.0, then you should consider to ensure that snap2one[2] < αmax.
"""
struct InitialConstantChange{T}
    αmin::T # Minimum initial step size (value somewhat arbitrary)
    αmax::T # Maximum initial step size
    α0::T   # Fallback at first iteration
    ρ::T    # maximum decrease from previous step
    snap2one::Tuple{T,T} # Set everything in this (closed) interval to 1.0
    dϕ_0_previous::Base.RefValue{T}
end

# Have to make this constructor without with_kw because Ref(NaN) has to adapt to T
function InitialConstantChange{T}(; αmin = 1e-12,
                        αmax = 1.0,
                        α0   = 1.0,
                        ρ    = 0.25,
                        snap2one = (0.75, Inf)) where T
    αmin, αmax, α0, ρ = convert.(T, (αmin, αmax, α0, ρ))
    snap2one = convert.(T, snap2one)
    InitialConstantChange(αmin, αmax, α0, ρ, snap2one, Ref(convert(T, NaN)))
end

# Have to make this constructor without with_kw because Ref(NaN) has to adapt to T
function InitialConstantChange(; αmin = 1e-12,
                        αmax = 1.0,
                        α0   = 1.0,
                        ρ    = 0.25,
                        snap2one = (0.75, Inf))
    T = promote_type(typeof.((αmin, αmax, α0, ρ))...)
    InitialConstantChange(αmin, αmax, α0, ρ, snap2one, Ref(convert(T, NaN)))
end

function (is::InitialConstantChange{T})(ls, state, phi_0, dphi_0, df) where T
    if !isfinite(is.dϕ_0_previous[]) || !isfinite(state.alpha) ||
        isapprox(dphi_0, convert(T, 0), atol=eps(T))
        # If we're at the first iteration
        αguess = is.α0
    else
        # state.alpha is the previously used step length
        αguess = state.alpha * is.dϕ_0_previous[] / dphi_0
        αguess = NaNMath.max(is.αmin, state.alpha*is.ρ, αguess)
        αguess = NaNMath.min(is.αmax, αguess)
        # if αguess ≈ 1, then make it 1 (Newton-type behaviour)
        if is.snap2one[1] ≤ αguess ≤ is.snap2one[2]
            αguess = one(state.alpha)
        end
    end
    is.dϕ_0_previous[] = dphi_0
    state.alpha = αguess
end


"""
Initial step size algorithm from
  W. W. Hager and H. Zhang (2006) Algorithm 851: CG_DESCENT, a
    conjugate gradient method with guaranteed descent. ACM
    Transactions on Mathematical Software 32: 113–137.

If α0 is NaN, then procedure I0 is called at the first iteration,
otherwise, we select according to procedure I1-2, with starting value α0.
"""
@kwdef struct InitialHagerZhang{T}
    ψ0::T          = 0.01
    ψ1::T          = 0.2
    ψ2::T          = 2.0
    ψ3::T          = 0.1
    αmax::T        = Inf
    α0::T          = 1.0 # Initial alpha guess. NaN => algorithm calculates
    quadstep::Bool = true
    verbose::Bool  = false
end

function (is::InitialHagerZhang)(ls::Tls, state, phi_0, dphi_0, df) where Tls
    if isnan(state.f_x_previous) && isnan(is.α0)
        # If we're at the first iteration (f_x_previous is NaN)
        # and the user has not provided an initial step size (is.α0 is NaN),
        # then we
        # pick the initial step size according to HZ #I0
        # phi_0 is (or should be) equal to NLSolversBase.value(df, state.x) 
        # TODO: Make the gradient available as part of the state?
        g_x = NLSolversBase.gradient!(df, state.x)
        state.alpha = _hzI0(state.x, g_x, phi_0,
                            is.αmax,
                            convert(eltype(state.x), is.ψ0)) # Hack to deal with type instability between is{T} and state.x
        if Tls <: HagerZhang
            ls.mayterminate[] = false
        end
    else
        # Pick the initial step size according to HZ #I1-2
        if Tls <: HagerZhang
            mayterminate = ls.mayterminate
        else
            mayterminate = Ref{Bool}(false)
        end
        T = eltype(state.alpha)
        state.alpha = _hzI12(state.alpha, df, state.x, state.s, state.x_ls, phi_0, dphi_0,
                   is.ψ1, is.ψ2, is.ψ3, T(is.αmax), is.verbose, is.quadstep, mayterminate)
    end
    return state.alpha
end

# Pick the initial step size (HZ #I1-I2)
function _hzI12(alpha::T,
                df,
                x::AbstractArray{Tx},
                s::AbstractArray{Tx},
                x_new::AbstractArray{Tx},
                phi_0::T,
                dphi_0::T,
                psi1::Real,
                psi2::Real,
                psi3::Real,
                alphamax::T,
                verbose::Bool,
                quadstep::Bool,
                mayterminate) where {Tx,T}
    ϕ = make_ϕ(df, x_new, x, s)

    # Prevent values of `x_new` that are likely to make
    # ϕ(x_new) infinite
    iterfinitemax::Int = ceil(Int, -log2(eps(T)))

    alphatest = psi1 * alpha
    alphatest = min(alphatest, alphamax)
    alphatest == 0 && return alphatest
    phitest = ϕ(alphatest)
    alphatest, phitest = get_finite(alphatest, phitest, ϕ, psi3, iterfinitemax, phi_0, mayterminate)
    alphatest == 0 && return alphatest

    mayterminate[] = quadstep_success = false
    if quadstep
        a = ((phitest - phi_0) / alphatest - dphi_0) / alphatest  # quadratic fit
        if verbose == true
            println("quadfit: alphatest = ", alphatest,
                    ", phi_0 = ", phi_0,
                    ", dphi_0 = ", dphi_0,
                    ", phitest = ", phitest,
                    ", quadcoef = ", a)
        end
        if isfinite(a) && a > 0 && phitest <= phi_0
            alphatest2 = -dphi_0 / 2 / a # if convex, choose minimum of quadratic
            alphatest2 = min(alphatest2, alphamax)
            phitest2 = ϕ(alphatest2)
            if isfinite(phitest2)
                mayterminate[] = quadstep_success = true
                alphatest = alphatest2
                phitest = phitest2
                if verbose == true
                    println("alpha guess (quadratic): ", alphatest,
                            ",(mayterminate = ", mayterminate[], ")")
                end
            end
        end
    end
    if (!quadstep || !quadstep_success) && phitest <= phi_0
        # If no quadstep or it fails, expand the interval.
        # While the phitest <= phi_0 condition was not in the paper, it gives a significant boost to the speed. The rationale behind it is that since the slope at alpha = 0 is negative, if phitest > phi_0 then a local minimum must be between alpha = 0 and alpha = alphatest, so alpha_test is good enough to return.
        alphatest = psi2 * alpha 
        alphatest = min(alphatest, alphamax)
        phitest = ϕ(alphatest)
        alphatest, phitest = get_finite(alphatest, phitest, ϕ, psi3, iterfinitemax, phi_0, mayterminate)
        if verbose == true
            println("alpha guess (expand): ", alphatest)
        end
    end
    return alphatest
end

# Generate initial guess for step size (HZ, stage I0)
function _hzI0(x::AbstractArray{Tx},
               gr::AbstractArray{Tx},
               f_x::T,
               alphamax::T,
               psi0::T = convert(T, 1)/100) where {Tx,T}
    zeroT = convert(T, 0)
    alpha = convert(T, 1)
    gr_max = maximum(abs, gr)
    if gr_max != zeroT
        x_max = maximum(abs, x)
        if x_max != zeroT
            alpha = psi0 * x_max / gr_max
        elseif f_x != zeroT
            alpha = psi0 * abs(f_x) / norm(gr)^2
        end
    end
    return min(alpha, alphamax)
end

function get_finite(alpha::T, phi, ϕ, factor, itermax, phi_0, mayterminate) where {T}
    iter = 1
    while !isfinite(phi)
        if iter >= itermax
            mayterminate[] = true
            return T(0), phi_0
        end

        alpha = factor * alpha
        phi = ϕ(alpha)
        iter += 1
    end
    return alpha, phi
end

```@meta
DocTestSetup = :(using LineSearches)
```

# Initial step length guess

Some of these routines are tightly integrated with `Optim`.

```@docs
InitialStatic
InitialPrevious
InitialQuadratic
InitialConstantChange
InitialHagerZhang
```

```@meta
DocTestSetup = :(using LineSearches)
```

# LineSearches.jl
*A line search toolbox written in Julia.*

## Introduction
`LineSearches` provides a collection of line search routines for
optimization and nonlinear solvers.  The package can be used on its
own, but it also provides extra supporting functionality for
[Optim.jl](https://github.com/JuliaNLSolvers/Optim.jl) and
[NLsolve.jl](https://github.com/JuliaNLSolvers/NLsolve.jl).


## Available line search algorithms
* `HagerZhang` (Taken from the Conjugate Gradient implementation
  by Hager and Zhang, 2006)
* `MoreThuente` (From the algorithm in More and Thuente, 1994)
* `BackTracking` (Described in Nocedal and Wright, 2006)
* `StrongWolfe` (Nocedal and Wright)
* `Static` (Takes the proposed initial step length.)

## Available initial step length procedures
The package provides some procedures to calculate the initial step
length that is passed to the line search algorithm, currently specialized to
be used with Optim and NLsolve.
* `InitialPrevious` (Use the step length from the previous
  optimization iteration)
* `InitialStatic` (Use the same initial step length each time)
* `InitialHagerZhang` (Taken from Hager and Zhang, 2006)
* `InitialQuadratic` (Propose initial step length based on a quadratic
  interpolation)
* `InitialConstantChange` (Propose initial step length assuming
  constant change in step length)

## Installation

To install, simply run the following in the Julia REPL:
```julia
Pkg.add("LineSearches")
```
and then run
```julia
using LineSearches
```
to load the package.

## Debugging

If you suspect a method of suboptimal performance or find that your code errors,
create a [`LineSearchCache`](@ref) to record intermediate values for later
inspection and analysis. If you're using this via Optim.jl, configure it inside
the method, e.g., `Newton(linesearch=LineSearches.MoreThuente(; cache))`. The
value stored in the cache will reflect the final iteration of line search during
optimization.

## References

- W. W. Hager and H. Zhang (2006) "Algorithm 851: CG_DESCENT, a conjugate gradient method with guaranteed descent." ACM Transactions on Mathematical Software 32: 113-137.
- Moré, Jorge J., and David J. Thuente. "Line search algorithms with guaranteed sufficient decrease." ACM Transactions on Mathematical Software (TOMS) 20.3 (1994): 286-307.
- Nocedal, Jorge, and Stephen Wright. "Numerical optimization." Springer Science & Business Media, 2006.
